/**
 * Created by janis dähne.
 */


declare module 'react-monaco-editor' {
  import * as React from "react";
  import IModelContentChangedEvent = monaco.editor.IModelContentChangedEvent;
  import IEditorOptions = monaco.editor.IEditorOptions;

  export interface MonacoEditorProps {
    readonly width?: number | string
    readonly height?: number | string
    readonly value: string | null
    readonly defaultValue?: string
    readonly language: string
    readonly theme?: string | null

    readonly options?: IEditorOptions,
    readonly editorDidMount?: (monaco: monaco.editor.IEditor) => void,
    readonly editorWillMount?: () => void,
    readonly onChange?: (newValue: string, changes: IModelContentChangedEvent) => void,
    readonly requireConfig?: any,

  }

  export interface _MonacoEditor extends React.ComponentClass<MonacoEditorProps> {

    /**
     * will be set by the component
     */
    readonly editor: monaco.editor.IEditor


  }

  export const MonacoEditor: _MonacoEditor
  export default MonacoEditor
}