/**
 * Created by janis dähne.
 */

import * as genericLayer from './genericLayer'
import {AssessmentStatisticsFullBase} from "../types/assessmentStatistics";
import {PaginationPostData} from '../types/pagination'

const callingName = 'assessmentStatisticsLayer'
const controllerPrefix = 'assessmentstatistics'


/**
 * returns the test statistics
 * @param {number} targetUserId if this is the current user then all assessments are returned, else (e.g. a tutor)
 * only the assessments are returned where the tutor has the proper permissions (form the managing group of the exercise)
 * the tutor needs can assess permission
 * @param paginationPostData
 * @returns {Promise<AssessmentStatisticsFullBase>}
 */
export async function getFullAssessmentStatistics(targetUserId: number, paginationPostData: PaginationPostData): Promise<AssessmentStatisticsFullBase> {
  return genericLayer.update<PaginationPostData, AssessmentStatisticsFullBase>(callingName,
    `${controllerPrefix}/all/${targetUserId}`, paginationPostData
  )
}