/**
 * Created by janis dähne.
 */
import * as genericLayer from './genericLayer'
import {LangFullBase} from "../types/languages";
import {PLangFullBase, PLangWithExtrasFromBackend} from '../types/pLangs'

const callingName = 'languages'
const controllerPrefix = 'langs'


/**
 * gets the time from the server
 */
export function getLanguages(): Promise<ReadonlyArray<LangFullBase>> {
  return genericLayer.get<ReadonlyArray<LangFullBase>>(callingName,
                                                       `${controllerPrefix}`
  )
}


export function createLang(lang: LangFullBase): Promise<LangFullBase> {
  return genericLayer.update<LangFullBase, LangFullBase>(callingName,
                                                         `${controllerPrefix}/create`, lang
  )
}

export function updateLang(lang: LangFullBase): Promise<LangFullBase> {
  return genericLayer.update<LangFullBase, LangFullBase>(callingName,
                                                         `${controllerPrefix}/update`, lang
  )
}

export function deleteLang(langId: number): Promise<void> {
  return genericLayer.del<void>(callingName, `${controllerPrefix}/delete/${langId}`)
}
