/**
 * Created by janis dähne.
 */

import * as React from "react";
import {Button, ButtonProps} from "semantic-ui-react";
import {RootState} from "../../state/reducers";
import {bindActionCreators, Dispatch} from "redux";
import {getI18n} from "../../../i18n/i18nRoot";
import {connect} from "react-redux";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState) => {
  return {
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
}, dispatch)

class ChangeButton extends React.Component<MyProps & ButtonProps, any> {
  render(): JSX.Element {

    const {langId, ...otherProps} = this.props
    return (
      <div>
        <Button
          content={getI18n(langId, 'Change')}
          icon='save'
          labelPosition='left'
          {...otherProps}
        >
        </Button>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(ChangeButton)