/**
 * Created by janis dähne.
 */

import * as React from "react";
import {Button, ButtonProps} from "semantic-ui-react";
import {RootState} from "../../state/reducers";
import {bindActionCreators, Dispatch} from "redux";
import {connect} from "react-redux";
import {getI18n} from "../../../i18n/i18nRoot";
import {CSSProperties} from 'react'

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
  readonly style?: CSSProperties
}

const mapStateToProps = (rootState: RootState) => {
  return {
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({}, dispatch)

//className={'ok-bg-colored white-colored ' + this.props.className}
class SaveButton extends React.Component<MyProps & ButtonProps, any> {
  render(): JSX.Element {

    const {langId, ...otherProps} = this.props

    return (<div>
        <Button
          content={getI18n(langId, 'Save')}
          icon='save'
          labelPosition='left'
          color="green"
          {...otherProps}
        >
        </Button>
      </div>)
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(SaveButton)