/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../state/reducers";
import {setIsSubHeaderBarCollapsed} from "../../state/actions/siteHeaderBarActions";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isSiteHeaderBarDisplayedAndEnabled: rootState.siteHeaderBarState.isSiteHeaderBarDisplayedAndEnabled,
    isSiteHeaderBarCollapsed: rootState.siteHeaderBarState.isSiteHeaderBarCollapsed,
    isSubHeaderBarCollapsed: rootState.siteHeaderBarState.isSubHeaderBarCollapsed,
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  setIsSubHeaderBarCollapsed
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class commonHeaderBar extends React.Component<Props, any> {

  render(): JSX.Element {

    return (
      <div className="site-content-header-outer">
        {
          <div>
            <div
              className={`${this.props.isSiteHeaderBarDisplayedAndEnabled && !this.props.isSiteHeaderBarCollapsed ? 'site-content-header' : 'site-content-header-no-site-header-bar'}${this.props.isSubHeaderBarCollapsed ? ' collapsed-i' : ''}`}>

              <div className="site-content-header-wrapper">
                {
                  this.props.children
                }

                {
                  !this.props.isSubHeaderBarCollapsed &&
                  <div className="individual-site-menu-collapse-arrow arrow-up" onClick={() => {
                    this.props.setIsSubHeaderBarCollapsed(true)
                  }}>
                  </div>
                }
              </div>
            </div>
          </div>
        }

        {
          this.props.isSubHeaderBarCollapsed &&
          <div className="individual-site-menu-expand-arrow arrow-down" onClick={() => {
            this.props.setIsSubHeaderBarCollapsed(false)
          }}>
          </div>
        }

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(commonHeaderBar)