/**
 * Created by janis dähne.
 */

import * as React from "react";
import {Icon} from "semantic-ui-react";
import MaterialInput from '../material/materialInput'

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
  readonly programArgs: string
  readonly setProgramArgs: (newArgs: string) => void
}

export const ProgramArgsInputView: React.SFC<MyProps> = (props) => {


  return (
    <div className="flexed">

      <MaterialInput style={{width: '250px'}} placeholder="args..."
                     value={props.programArgs}
                     onChange={(e: React.SyntheticEvent<HTMLInputElement>) => {
                       props.setProgramArgs(e.currentTarget.value)
                     }}/>

      <div className="clickable" style={{alignSelf: 'center'}} onClick={() => {
        props.setProgramArgs("")
      }}>
        <Icon name="x"/>
      </div>

    </div>
  )
}