/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {Icon} from "semantic-ui-react";
import CommonHeaderBarContentWrapper from '../../../commonHeaderBarContentWrapper'
import {
  setIsEnterReleaseCodeDialogDisplayed, setIsTagsFilterDisplayed
} from "../../../../state/actions/allAccessibleExercises/openExercisesSite/openExercisesSiteActions";
import {RootState} from "../../../../state/reducers";
import {getI18n} from "../../../../../i18n/i18nRoot";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isEnterReleaseCodeDialogDisplayed: rootState.openExercisesState.isEnterReleaseCodeDialogDisplayed,
    isLoading: rootState.openExercisesState.isLoading,

    selectedFilterTagsIds: rootState.tagsFilterState.selectedFilterTagsIds,
    selectedNegativeFilterTagsIds: rootState.tagsFilterState.selectedNegativeFilterTagsIds,

    isTagsFilterDisplayed: rootState.openExercisesState.isTagsFilterDisplayed,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  setIsEnterReleaseCodeDialogDisplayed,
  setIsTagsFilterDisplayed
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class HeaderBar extends React.Component<Props, any> {
  render(): JSX.Element {

    const leftArea = (
      <div>

        <div className="clickable"
             onClick={() => this.props.setIsEnterReleaseCodeDialogDisplayed(true)}
        >
          <Icon name="privacy"/>
          <span>
            {
              getI18n(this.props.langId,'Enter release code')
            }
          </span>
        </div>

      </div>
    )

    const rightArea = (
      <div className="flexed">

        <div className={`clickable mar-right-half ${(this.props.isTagsFilterDisplayed || this.props.selectedFilterTagsIds.length > 0 || this.props.selectedNegativeFilterTagsIds.length > 0) ? 'toggled-colored' : ''}`}
             onClick={() => {
               this.props.setIsTagsFilterDisplayed(!this.props.isTagsFilterDisplayed)
             }}
        >
          <Icon name="filter" />
        </div>

      </div>
    )

    return (
      <CommonHeaderBarContentWrapper leftArea={leftArea} rightArea={rightArea} disabled={this.props.isLoading || this.props.isEnterReleaseCodeDialogDisplayed}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(HeaderBar)