/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers";
import {Icon} from "semantic-ui-react";
import {SimpleVDivider} from "../../../helpers/simpleVDivider";
import {
  setAfterSolutionFiles,
  setIsDoCodeEditorSettingsDialogDisplayed
} from "../../../../state/actions/doExerciseSite/doExerciseSiteActions";
import {openEditEditorSettingsDialog} from "../../../../state/actions/editorSettingsDialog/editorSettingsDialogActions";
import {getI18n} from "../../../../../i18n/i18nRoot";
import {displayDateAndTime} from '../../../../helpers/convertersAndTransformers'
import {MyPopup} from '../../../helpers/myPopup'

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    codeEditorSettings: rootState.userDataSettingsSate.userData.settings ?
      rootState.userDataSettingsSate.userData.settings.codeEditorSettings
      : null,

    pLang: rootState.doExerciseSiteState.solution.pLangId,
    pLangs: rootState.pLangsState.pLangs,
    solution: rootState.doExerciseSiteState.solution,
    afterSolution: rootState.doExerciseSiteState.afterSolution,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  setIsDoCodeEditorSettingsDialogDisplayed,
  openEditEditorSettingsDialog,
  setAfterSolutionFiles,
  // resetAfterEditor
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class editorPanelHeaderBar extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div className="flexed">

        <div className="clickable"
             onClick={() => {
               this.props.openEditEditorSettingsDialog(this.props.codeEditorSettings,
                 this.props.setIsDoCodeEditorSettingsDialogDisplayed)
             }}
        >
          <Icon name="settings"/>
          <span>
            {
              getI18n(this.props.langId,'Editor settings')
            }
          </span>
        </div>

        {/* currently not supported, see doExerciseSiteAction > resetAfterEditor why */}
        {/*<SimpleVDivider/>*/}

        {/*<div className="mar-right-half clickable"*/}
             {/*onClick={async () => {*/}


               {/*const shouldReset = await askDialog(getI18n(this.props.langId,'Reset code'),*/}
                 {/*getI18n(this.props.langId,'Are you sure you want to reset your code to your submitted solution?'))*/}

               {/*if (shouldReset) {*/}
                 {/*this.props.resetAfterEditor(this.props.pLangs, this.props.solution)*/}
               {/*}*/}

             {/*}}*/}
        {/*>*/}
          {/*<Icon name="undo"/>*/}
          {/*<span>*/}
            {/*{*/}
              {/*getI18n(this.props.langId,'Reset code')*/}
            {/*}*/}
          {/*</span>*/}
        {/*</div>*/}
        {/*<HelpPopup*/}
          {/*defaultText={getI18n(this.props.langId,'Resets the code to your readonly solution')}*/}
        {/*/>*/}

        {
          this.props.afterSolution.id > 0 &&
          <SimpleVDivider/>
        }

        {
          this.props.afterSolution.id > 0 &&
          <MyPopup
            trigger={
              <div className="hoverable">

                <Icon className="mar-right-half" name="database"/>
                <span className="mar-right-half">
              {
                getI18n(this.props.langId, 'Server version:')
              }
              </span>
                <span>
              {
                displayDateAndTime(this.props.afterSolution.lastUpdatedAt, -1)
              }
              </span>
              </div>
            }
            content={getI18n(this.props.langId, 'The time when the latest solution was saved/created on the server.')}
          />
        }

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(editorPanelHeaderBar)