import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from '../../../../../state/reducers'
import {Button} from 'semantic-ui-react'
import {getI18n} from '../../../../../../i18n/i18nRoot'
import CancelButton from '../../../../buttons/cancelButton'
import history from '../../../../../routerHistory'
import * as constants from '../../../../../constants'
import {setIsChoosePLangDialogDisplayed} from '../../../../../state/actions/editCustomProjectSite/editCustomProjectActions'

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {

    customProject: rootState.editCustomProjectSiteState.customProject,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
                                                                        //imported reducer funcs here
                                                                        setIsChoosePLangDialogDisplayed,
                                                                      }, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;


class ChoosePLangActions extends React.Component<Props, any> {
  render(): JSX.Element {

    return (
      <div>

        <Button
          style={{float: 'left'}}
          className="mar-right"
          disabled={this.props.customProject.solution.pLangId <= 0}
          content={getI18n(this.props.langId, 'Ok')}
          icon='checkmark'
          labelPosition='left'
          color="green"
          onClick={() => {

            this.props.setIsChoosePLangDialogDisplayed(false)
          }}
        >
        </Button>

        <CancelButton onClick={() => {
          history.push(constants.manageCustomProjectsSiteLinkMatchPath)
        }}/>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(ChoosePLangActions)
