/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers";
import {Link} from "react-router-dom";
import * as constants from '../../../../constants'
import {Icon} from "semantic-ui-react";


import {getI18n} from "../../../../../i18n/i18nRoot";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class exerciseSyntaxHelpPanelHeaderBar extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div className="flexed">

        <Link target="_blank" to={constants.markdownSiteExerciseSyntaxGuide}>
          <Icon className="mar-right-half" name="external share"/>
          <span>
            {
              getI18n(this.props.langId,'Open help in new tab')
            }
          </span>
        </Link>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(exerciseSyntaxHelpPanelHeaderBar)