 /**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers";
import {Icon} from "semantic-ui-react";
import {openCreateEditorTestDialog} from "../../../../state/actions/exerciseEditorSite/dialogs/changeTestDialog/changeTestDialogActions";


 import {getI18n} from "../../../../../i18n/i18nRoot";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string

  /**
   * true: manages submit tests,
   * false: the component manages normal tests
   */
  readonly isForSubmitTests: boolean
}

const mapStateToProps = (rootState: RootState, props: MyProps) => {
  return {
    //test0: rootState...
    //test: props.test
    tests: rootState.exerciseEditorState.editorExercise.tests.filter(
      p => p.isSubmitTest === props.isForSubmitTests),
    isForSubmitTests: props.isForSubmitTests,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  openCreateEditorTestDialog
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class ChangeTestsPanelHeaderBar extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div className="flexed">
        <div className="clickable"
             onClick={() => {
               this.props.openCreateEditorTestDialog(this.props.isForSubmitTests)
             }}
        >
          <Icon name="add"/>
          <span>
            {
              getI18n(this.props.langId,'Add')
            }
          </span>
        </div>

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(ChangeTestsPanelHeaderBar)