/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../../state/reducers";
import FullSiteDialog from '../../../../fullSiteDialog'
import {
  applyChangeSelectedTagDialog,
  cancelChangeSelectedTagDialog
} from "../../../../../state/actions/exerciseEditorSite/dialogs/changeSelectedTagsDialog/changeTestDialogActions";
import ChangeSeleectedTagsView from './changeSelectedTagsView'


import {getI18n} from "../../../../../../i18n/i18nRoot";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isBusy: rootState.changeSelectedTagsDialogState.isBusy,
    isValid: true,
    selectedTagIds: rootState.changeSelectedTagsDialogState.selectedTagIds,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  cancelChangeSelectedTagDialog,
  applyChangeSelectedTagDialog,
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class changeSelectedTagsDialog extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <FullSiteDialog
        isBusy={this.props.isBusy}
        isValid={this.props.isValid}
        caption={
          <h2>
            {
              getI18n(this.props.langId,'Choose tags')
            }
          </h2>
        }
        onSave={() => {
          this.props.applyChangeSelectedTagDialog(this.props.selectedTagIds)
        }}
        onCancel={() => {
          this.props.cancelChangeSelectedTagDialog()
        }}
      >
        <ChangeSeleectedTagsView/>
      </FullSiteDialog>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(changeSelectedTagsDialog)