/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../../state/reducers";
import {Label, Icon, Popup} from "semantic-ui-react";
import Tag from '../../../../tagComponents/tag'
import {setSelectedTagIds} from "../../../../../state/actions/exerciseEditorSite/dialogs/changeSelectedTagsDialog/changeTestDialogActions";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    selectedTagIds: rootState.changeSelectedTagsDialogState.selectedTagIds,
    allTags: rootState.exerciseEditorState.tags,
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  setSelectedTagIds
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class changeSelectedTagsView extends React.Component<Props, any> {
  render(): JSX.Element {

    const notTakenTags = this.props.allTags.filter(p =>
      this.props.selectedTagIds
        .every(takenTagId =>
          takenTagId !== p.id
        )
    )

    return (
      <div className="flexed">
        {
          notTakenTags.map((tag, index2) => {
            return (
              <div className="clickable" key={tag.id} onClick={() => {
                this.props.setSelectedTagIds([...this.props.selectedTagIds, tag.id])
              }}
              >
                <Tag tag={tag}/>
              </div>
            )
          })
        }
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(changeSelectedTagsView)