/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers";
import {Icon} from "semantic-ui-react";
import {SimpleVDivider} from "../../../helpers/simpleVDivider";
import {openEditChangeSelectedTagDialog} from "../../../../state/actions/exerciseEditorSite/dialogs/changeSelectedTagsDialog/changeTestDialogActions";
import {setTagIds} from "../../../../state/actions/exerciseEditorSite/subSets/editorExerciseMetaDataActions";


import {getI18n} from "../../../../../i18n/i18nRoot";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    tagIds: rootState.exerciseEditorState.editorExercise.metaData.tagIds,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  openEditChangeSelectedTagDialog,
  setTagIds
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class tagsPanelHeaderBar extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div className="flexed">
        <div className="clickable"
             onClick={() => {
               this.props.openEditChangeSelectedTagDialog(this.props.tagIds)
             }}
        >
          <Icon name="add"/>
          <span>
            {
              getI18n(this.props.langId,'Add')
            }
          </span>
        </div>

        <SimpleVDivider/>

        <div className="clickable"
             onClick={() => {
               this.props.setTagIds([])
             }}
        >
          <Icon name="remove"/>
          <span>
            {
              getI18n(this.props.langId,'Remove all')
            }
          </span>
        </div>

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(tagsPanelHeaderBar)