/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers";
import {Label, Icon} from "semantic-ui-react";
import Tag from '../../../tagComponents/tag'
import {setTagIds} from "../../../../state/actions/exerciseEditorSite/subSets/editorExerciseMetaDataActions";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    tagIds: rootState.exerciseEditorState.editorExercise.metaData
      ? rootState.exerciseEditorState.editorExercise.metaData.tagIds
      : [],
    allTags: rootState.exerciseEditorState.tags
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  setTagIds
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class tagsPanelView extends React.Component<Props, any> {
  render(): JSX.Element {

    const tags = this.props.tagIds.map(tagId =>
      this.props.allTags.find(tag => tagId === tag.id)
    ).filter(p => p)


    return (
      <div className="flexed">
        {
          tags.map((tag, index2) => {
            return (
              <div key={tag.id}>
                <Tag tag={tag}
                     rightIconName="remove"
                     onRightIconClicked={() => {
                       this.props.setTagIds(this.props.tagIds.filter(id => id !== tag.id))
                     }}
                />
              </div>
            )
          })
        }
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(tagsPanelView)