/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers";
import {Form} from "semantic-ui-react";
import MaterialInput from '../../../material/materialInput'
import {setDisplayName, setEmail, setId} from "../../../../state/actions/groupsSite/dialog/groupSetActions";
import {validationRules} from "../../../../state/reducers/groupsSite/dialog/groupReducer";
import {validationMessageKeys} from "../../../../state/reducers/groupsSite/dialog/groupReducerValidation";
import {getI18n} from "../../../../../i18n/i18nRoot";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    group: rootState.changeGroupDialogState.group,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  setId,
  setDisplayName,
  setEmail
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class ChangeGroupDataView extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div>

        <div>
          <div className="ui form">
            <Form.Group widths='equal'>
              <Form.Field required>
                <label>
                  {
                    getI18n(this.props.langId,'Name')
                  }
                </label>
                <MaterialInput
                  value={this.props.group.displayName}
                  onChange={(e) => this.props.setDisplayName(e.currentTarget.value)}
                  validations={validationRules.displayName}
                  validationMessageKey={validationMessageKeys.displayName}
                />
              </Form.Field>
              <Form.Field>
                <label>
                  {
                    getI18n(this.props.langId,'Email')
                  }
                </label>
                <MaterialInput
                  value={this.props.group.email}
                  onChange={(e) => this.props.setEmail(e.currentTarget.value)}
                  validations={validationRules.email}
                  validationMessageKey={validationMessageKeys.email}
                />
              </Form.Field>
            </Form.Group>

          </div>
        </div>

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(ChangeGroupDataView)