/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers";
import CommonHeaderBarContentWrapper from '../../commonHeaderBarContentWrapper'
import {Icon} from "semantic-ui-react";
import {openCreateGroupDialog} from "../../../state/actions/groupsSite/groupsSiteActions";
import {getI18n} from "../../../../i18n/i18nRoot";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isLoading: rootState.groupsState.isLoading,
    isChangeDialogDisplayed: rootState.groupsState.isChangeDialogDisplayed,

    systemRole: rootState.userDataSettingsSate.userData
    && rootState.userDataSettingsSate.userData.systemRole
      ? rootState.userDataSettingsSate.userData.systemRole
      : null,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  openCreateGroupDialog
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class headerBarContent extends React.Component<Props, any> {
  render(): JSX.Element {

    const leftArea = (
      <div>
        {
          (this.props.systemRole && this.props.systemRole.canCreateGroups) &&
          <div className="clickable"
               onClick={() => {
                 this.props.openCreateGroupDialog()
               }}
          >
            <Icon name="plus"/>
            <span>
            {
              getI18n(this.props.langId,'Create group')
            }
          </span>
          </div>
        }

      </div>
    )

    return (
      <CommonHeaderBarContentWrapper leftArea={leftArea} disabled={this.props.isLoading || this.props.isChangeDialogDisplayed}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(headerBarContent)