/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers";
import {Icon} from "semantic-ui-react";
import CommonHeaderBarContentWrapper from '../../commonHeaderBarContentWrapper'
import MaterialSearch from '../../material/materialSearchInput'
import {
  setIsTagsFilterDisplayed,
} from "../../../state/actions/manageGroupExercisesSite/groupExercisesSiteActions";
import {Link} from "react-router-dom";
import * as constants from '../../../constants'


import {getI18n} from "../../../../i18n/i18nRoot";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isLoading: rootState.manageGroupExercisesState.isLoading
    || rootState.manageTagsState.isLoading,

    selectedFilterTagsIds: rootState.tagsFilterState.selectedFilterTagsIds,
    selectedNegativeFilterTagsIds: rootState.tagsFilterState.selectedNegativeFilterTagsIds,

    tempCanCreateExercise: rootState.userDataSettingsSate.userData
    && rootState.userDataSettingsSate.userData
      ? rootState.userDataSettingsSate.userData.tempCanCreateExercise
      : false,

    isTagsFilterDisplayed: rootState.manageGroupExercisesState.isTagsFilterDisplayed,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  setIsTagsFilterDisplayed
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class HeaderBar extends React.Component<Props, any> {
  render(): JSX.Element {


    const leftArea = (
      <div>
        {
          this.props.tempCanCreateExercise &&
          <div>
            <Link to={constants.getExerciseEditorCreateNewLinkPath(false)}>
              <Icon name="plus"/>
              <span>
            {
              getI18n(this.props.langId,'Create exercise')
            }
          </span>
            </Link>
          </div>
        }
      </div>
    )

    const middleArea = (
      <div>
      </div>
    )

    const rightArea = (
      <div className="flexed">

        <div className={`clickable mar-right-half ${(this.props.isTagsFilterDisplayed || this.props.selectedFilterTagsIds.length > 0 || this.props.selectedNegativeFilterTagsIds.length > 0) ? 'toggled-colored' : ''}`}
             onClick={() => {
               this.props.setIsTagsFilterDisplayed(!this.props.isTagsFilterDisplayed)
             }}
        >
          <Icon name="filter" />
        </div>

      </div>
    )

    return (
      <CommonHeaderBarContentWrapper leftArea={leftArea} middleArea={middleArea} rightArea={rightArea} disabled={this.props.isLoading}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(HeaderBar)