/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers";
import {Form} from "semantic-ui-react";
import MaterialInput from '../../material/materialInput'
import {
  setEmail, setNewPassword, setNewPasswordCheck, setOldPassword
} from "../../../state/actions/settingsSite/setUserDataActions";
import {validationRules} from "../../../state/reducers/settingsSite/userDataCopyReducer";
import {validationMessageKeys} from "../../../state/reducers/settingsSite/userDataCopyReducerValidation";
import {getI18n} from "../../../../i18n/i18nRoot";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    userDataCopy: rootState.userDataSettingsSate.userDataCopy,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  setNewPassword,
  setOldPassword,
  setEmail,
  setNewPasswordCheck
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class ownInformationSettingsChangeView extends React.Component<Props, any> {
  render(): JSX.Element {

    const wantsToChangePw = this.props.userDataCopy.oldPassword.trim() !== ''
      || this.props.userDataCopy.newPassword.trim() !== ''
      || this.props.userDataCopy.newPasswordCheck.trim() !== ''

    return (
      <div>
        <Form.Field required>
          <label>
            {
              getI18n(this.props.langId,'Email')
            }
          </label>
          <MaterialInput value={this.props.userDataCopy.email}
                         onChange={(e) => {
                           this.props.setEmail(e.currentTarget.value)
                         }}
                         validations={validationRules.email}
                         validationMessageKey={validationMessageKeys.email}
          />
        </Form.Field>

        <Form.Group widths='equal'>
          <Form.Field
            required={wantsToChangePw}
          >
            <label>
              {
                getI18n(this.props.langId,'Old password')
              }
            </label>
            <MaterialInput value={this.props.userDataCopy.oldPassword} type="password"
                           onChange={(e) => {
                             this.props.setOldPassword(e.currentTarget.value)
                           }}
                           validations={validationRules.oldPassword}
                           validationMessageKey={validationMessageKeys.oldPassword}
            />
          </Form.Field>

          <Form.Field
            required={wantsToChangePw}
          >
            <label>
              {
                getI18n(this.props.langId,'New password')
              }
            </label>
            <MaterialInput value={this.props.userDataCopy.newPassword} type="password"
                           onChange={(e) => {
                             this.props.setNewPassword(e.currentTarget.value)
                           }}
                           validations={validationRules.newPassword}
                           validationMessageKey={validationMessageKeys.newPassword}
            />
          </Form.Field>

          <Form.Field
            required={wantsToChangePw}
          >
            <label>
              {
                getI18n(this.props.langId,'New password again')
              }
            </label>
            <MaterialInput value={this.props.userDataCopy.newPasswordCheck} type="password"
                           onChange={(e) => {
                             this.props.setNewPasswordCheck(e.currentTarget.value)
                           }}
            />
          </Form.Field>
        </Form.Group>

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(ownInformationSettingsChangeView)