/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers";

import OwnInformationSettingsView from './ownInformationSettingsView'
import MiscSettingsView from './miscSettingsView'
import {loadSettingsSite} from "../../../state/actions/settingsSite/userSettingsSiteActions";
import {errorDialog} from '../../../helpers/dialogHelper'
import {getI18n} from '../../../../i18n/i18nRoot'
import Logger from '../../../helpers/logger'
import {ErrorHelper} from '../../../helpers/errorHelper'

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  loadSettingsSite
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class SettingSite extends React.Component<Props, any> {

  async componentWillMount(): Promise<void> {
    try {
      await this.props.loadSettingsSite()
    } catch(err) {
      ErrorHelper.makeServerErrorDialog(err, this.props.langId, 'Error', 'Could not load site data')
    }
  }

  render(): JSX.Element {
    return (
      <div className="multiple-single-panels">

        <OwnInformationSettingsView/>

        <MiscSettingsView />

      </div>

    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(SettingSite)