/**
 * Created by janis dähne.
 */

import * as React from "react";
import * as ReactDOM from "react-dom";
import {Provider} from 'react-redux'
import App from './app'

import store from './state/state'
import {Router, Route} from "react-router";
import LoginOverlay from './components/login/loginOverlay'
import history from './routerHistory'
import {setup} from './setup'
import {NotificationContainer} from "react-notifications";

//according to https://stackoverflow.com/questions/14990369/how-does-stylus-variable-scope-work-across-files
//we only need one file importing all other then all imported files iwll have the same scope
// const common = require('./styles/common.styl')
// const behaviours = require('./styles/behaviours.styl')
const allStyles = require('./allStyles.styl')

setup()


ReactDOM.render(
  <Provider store={store}>
    <Router history={history}>
      <Route path="/" component={() =>
        <div className="fh">
          <LoginOverlay>
            <App/>
          </LoginOverlay>
          <NotificationContainer/>
        </div>
      }/>
    </Router>
  </Provider>
  ,
  document.getElementById("root")
)

