# Aufgaben Syntax

## Beispiele

```
[question=md/pdf/txt/latex]
Die Aufgabenstellung
```
## [question] - Tag
Hier wird die Aufgabenstellung angegeben.
Es ist nur eine Aufgabenstellung aufgabenstellung erlaubt.

Als Format stehen Markdown (md), Pdf (pdf), normaler Text (txt) zur Auswahl.

* ### Markdown (md) 
 Links: [https://github.com/adam-p/markdown-here/wiki/Markdown-Cheatsheet](https://github.com/adam-p/markdown-here/wiki/Markdown-Cheatsheet), [https://de.wikipedia.org/wiki/Markdown](https://de.wikipedia.org/wiki/Markdown)
* Der Latex-Mathe-Modus wird mittels MathJax unterstützt. 
$$ für einen Inline-Modus (z.b. $a_b) und
 
2x $$ für den Formel-Modus (eigene Zeile) (analog Latex).

Hinweise: 
Innerhalb der Formeln wird markdown ignoriert. Um die Formeln herum kann kein markdown benutzt werden 
z.B. ** $ formel$ ** kann nicht fett geschrieben werden.
Auch sollte beachtet werden, dass es zu Problemen kommen kann, wenn man in einem Absatz mehrere Zeilen mit jeweils einem Dollar-Zeichen benutzt, welche zusammen (über mehrere Zeilen) Text einschließen (was einer Formel entspricht).
Gleiches gilt für 2x $$ Formel-Modus.

**Aus Sicherheitsgründen ist Html nicht möglich**

```
[question=md]
Frage mit **Markdown**
Latex-Mathe-Modus wird ebenfalls unterstützt: $x^2 + y^2 = c^2$ 
und auch in eigener Zeile: \\[ x^2 + y^2 = c^2 \\] (latex) sollte $$x^2 + y^2 = c^2$$ sein

Dennoch kann man Bilder auch mit markdown einbinden:
`![not found](asset://[Id des Bildes])`

Das Bild muss vorher als Asset hinzugefügt werden.
Danach kann der entsprechende Button im `Assets` Panel benutzt werden, um die Id des Bildes zu ermitteln.
```

#### Syntax highlighting 

ist möglich mittels fenced code blocks


```text
'''java
class Main {
}
'''
```

(die ''' durch ``` ersetzen, da sie sonst hier interpretiert würden)

Außerdem können mit `--line-numbers` Zeilennummern angezeigt werden

```text
'''java --line-numbers
class Main {
}
'''
```


Für eine List mit Sprachen siehe Abschnitt `Syntax highlighting unterstützte Sprachen` (ganz unten) 


* ### Pdf (pdf)
Es kann **eine** Url zu einem Pdf angegeben werden. Die Url muss dabei eine Asset-Url sein (beginnt mit asset://).
Das Pdf muss dazu als Asset hinzugefügt werden.

```
[question=pdf]
asset://[Id des Pdf]
```

Danach kann der entsprechende Button im `Assets` Panel benutzt werden, um die Id des Pdf zu ermitteln.

Beachten Sie, dass die Vorschau sich bei pdf nur schlecht automatisch aktualisiert. Falls die Vorschau daher nicht automatisch aktualisiert wird, wechseln Sie bitte den Tab (z.B. nach Anleitung oder Eigenschaften und wieder zu Vorschau), danach sollte die Vorschau aktualisiert werden.

* ### normaler Text (txt)
Es kann nur normaler Text geschrieben werden.

```
[question=txt]
Nur normaler Text erlaubt
```

### Syntax highlighting unterstützte Sprachen

siehe auch https://highlightjs.org/static/demo/ 

- 1c
- abnf
- accesslog
- actionscript
- ada
- apache
- applescript
- arduino
- armasm
- asciidoc
- aspectj
- autohotkey
- autoit
- avrasm
- awk
- axapta
- bash
- basic
- bnf
- brainfuck
- cal
- capnproto
- ceylon
- clean
- clojure
- clojure
- cmake
- coffeescript
- coq
- cos
- cpp
- crmsh
- crystal
- cs
- csp
- css
- d
- dart
- delphi
- diff
- django
- dns
- dockerfile
- dos
- dsconfig
- dts
- dust
- ebnf
- elixir
- elm
- erb
- erlang
- erlang
- excel
- fix
- flix
- fortran
- fsharp
- gams
- gauss
- gcode
- gherkin
- glsl
- go
- golo
- gradle
- groovy
- haml
- handlebars
- haskell
- haxe
- hsp
- htmlbars
- http
- hy
- inform7
- ini
- irpf90
- java
- javascript
- jboss
- json
- julia
- julia
- kotlin
- lasso
- ldif
- leaf
- less
- lisp
- livecodeserver
- livescript
- llvm
- lsl
- lua
- makefile
- markdown
- mathematica
- matlab
- maxima
- mel
- mercury
- mipsasm
- mizar
- mojolicious
- monkey
- moonscript
- n1ql
- nginx
- nimrod
- nix
- nsis
- objectivec
- ocaml
- openscad
- oxygene
- parser3
- perl
- pf
- php
- pony
- powershell
- processing
- profile
- prolog
- protobuf
- puppet
- purebasic
- python
- q
- qml
- r
- rib
- roboconf
- routeros
- rsl
- ruby
- ruleslanguage
- rust
- scala
- scheme
- scilab
- scss
- shell
- smali
- smalltalk
- sml
- sqf
- sql
- stan
- stata
- step21
- stylus
- subunit
- swift
- taggerscript
- tap
- tcl
- tex
- thrift
- tp
- twig
- typescript
- vala
- vbnet
- vbscript
- vbscript
- verilog
- vhdl
- vim
- x86asm
- xl
- xml
- xquery
- yaml
- zephir
