import {delay} from "../../../../debug";
import {GET_clientServerSettingsAction} from "../../reducers/dashboardSite/crud/getClientServerSystemSettingsReducer";
import {ActionType} from "../../reducers/dashboardSite/dashboardSiteActionTypes";
import {
  getClientServerAppSettings,
  getClientServerConstants,
  getClientServerSystemSettings, getHardwareUsage, getLogicalUsage,
  getTestServerSettings
} from "../../../communicationLayer/dashboardLayer";
import {GET_hardwareUsageAction} from "../../reducers/dashboardSite/crud/getHardwareUsageReducer";
import {GET_logicalUsageAction} from "../../reducers/dashboardSite/crud/getLogicalUsageReducer";
import {GET_testServerPrivateSettingsAction} from "../../reducers/dashboardSite/crud/getTestServerPrivateSettingsReducer";
import {GET_clientServerConstantsAction} from '../../reducers/dashboardSite/crud/getClientServerConstantsReducer'
import {GET_clientServerAppSettingsAction} from '../../reducers/dashboardSite/crud/getClientServerAppSettingsReducer'
import {GET_submitTestServerSettingsAction} from '../../reducers/dashboardSite/crud/getSubmitTestServerPrivateSettingsReducer'

/**
 * Created by janis dähne.
 */


export function getHardwareUsageAsync(): GET_hardwareUsageAction {
  return {
    type: ActionType.GET_hardwareUsage,
    payload: delay(getHardwareUsage())
  }
}

export function getLogicalUsageAsync(): GET_logicalUsageAction {
  return {
    type: ActionType.GET_logicalUsage,
    payload: delay(getLogicalUsage())
  }
}

export function getClientServerSystemSettingsAsync(): GET_clientServerSettingsAction {
  return {
    type: ActionType.GET_clientServerSettings,
    payload: delay(getClientServerSystemSettings())
  }
}

export function getClientServerConstantsAsync(): GET_clientServerConstantsAction {
  return {
    type: ActionType.GET_clientServerConstants,
    payload: delay(getClientServerConstants())
  }
}

export function getClientServerAppSettingsAsync(): GET_clientServerAppSettingsAction {
  return {
    type: ActionType.GET_clientServerAppSettings,
    payload: delay(getClientServerAppSettings())
  }
}

export function getTestServerPrivateSettingsAsync(): GET_testServerPrivateSettingsAction {
  return {
    type: ActionType.GET_testServerPrivateSettings,
    payload: delay(getTestServerSettings(false))
  }
}

export function getSubmitTestServerPrivateSettingsAsync(): GET_submitTestServerSettingsAction {
  return {
    type: ActionType.GET_submitTestServerSettings,
    payload: delay(getTestServerSettings(true))
  }
}


