import {AwaitActions} from "../types";
import {
  getClientServerAppSettingsAsync,
  getClientServerConstantsAsync,
  getClientServerSystemSettingsAsync,
  getHardwareUsageAsync,
  getLogicalUsageAsync,
  getSubmitTestServerPrivateSettingsAsync,
  getTestServerPrivateSettingsAsync
} from "./dashboardCrudActions";
import {
  ResetAction,
  SET_isHardwareUsageStatisticRefreshingAction,
  SET_isLoadingAction
} from "../../reducers/dashboardSite/dashboardSiteReducer";
import {ActionType} from "../../reducers/dashboardSite/dashboardSiteActionTypes";


export function loadDashboardSite(): AwaitActions {
  return async (dispatch, getState) => {

    dispatch(resetDashboardSite())


    try {
      await dispatch(getLogicalUsageAsync())
    } catch(err) {

    }

    try {
      await dispatch(getClientServerSystemSettingsAsync())
    } catch(err) {

    }

    try {
      await dispatch(getTestServerPrivateSettingsAsync())
    } catch(err) {

    }

    try {
      await dispatch(getSubmitTestServerPrivateSettingsAsync())
    } catch(err) {

    }

    try {
      await dispatch(getClientServerConstantsAsync())
    } catch(err) {

    }

    try {
      await dispatch(getClientServerAppSettingsAsync())
    } catch(err) {

    }

    dispatch(setIsLoadingDashboardSite(true))

    try {
      await dispatch(getHardwareUsageAsync())
    } catch(err) {

    }
    finally {
      dispatch(setIsLoadingDashboardSite(false))
    }

  }
}

export function setIsLoadingDashboardSite(isLoading: boolean): SET_isLoadingAction {
  return {
    type: ActionType.SET_isLoading,
    isLoading
  }
}

export function setIsHardwareUsageStatisticRefreshing(isRefreshing: boolean): SET_isHardwareUsageStatisticRefreshingAction {
  return {
    type: ActionType.SET_isHardwareUsageStatisticRefreshing,
    isRefreshing
  }
}



export function resetDashboardSite(): ResetAction {
  return {
    type: ActionType.RESET
  }
}
