/**
 * Created by janis dähne.
 */
import {CREATE_customTestAction} from "../../../../reducers/doExerciseSite/dialogs/changeCustomTestDialog/createCustomTestReducer";
import {ActionType} from "../../../../reducers/doExerciseSite/dialogs/changeCustomTestDialog/changeCustomTestDialogActionTypes";
import {ActionType as ActionTypeDoEditor} from "../../../../reducers/doExerciseSite/doExerciseSiteActionTypes";
import {delay} from "../../../../../../debug";
import {
  attachExitingFileToCustomTest,
  createCustomTest, detachFileFromCustomTest,
  updateCustomTest
} from "../../../../../communicationLayer/doExerciseLayer";
import {CustomTestForBackend} from "../../../../../types/customTests";
import {UPDATE_customTestAction} from "../../../../reducers/doExerciseSite/dialogs/changeCustomTestDialog/updateCustomTestReducer";
import {ATTACH_customTestAssetPreviewAction} from '../../../../reducers/doExerciseSite/crud/assets/attachCustomTestAssetPreviewReducer'
import {DETACH_customTestAssetPreviewAction} from '../../../../reducers/doExerciseSite/crud/assets/detachCustomTestAssetPreviewReducer'


export function createCustomTestDoEditor(releaseCode: string, customTest: CustomTestForBackend): CREATE_customTestAction {
  return {
    type: ActionType.CREATE_customTest,
    payload: delay(createCustomTest(releaseCode, customTest))
  }
}

export function updateCustomTestDoEditor(releaseCode: string, customTest: CustomTestForBackend): UPDATE_customTestAction {
  return {
    type: ActionType.UPDATE_customTest,
    payload: delay(updateCustomTest(releaseCode, customTest))
  }
}

export function attachExitingFileToCustomTestAsync(releaseCode: string, customTestId: number, fileReferenceId: number): ATTACH_customTestAssetPreviewAction {
  return {
    type: ActionTypeDoEditor.ATTACH_customTestAssetPreview,
    payload: delay(attachExitingFileToCustomTest(releaseCode, customTestId, fileReferenceId)),
    meta: {
      customTestId
    }
  }
}

export function detachFileFromCustomTestAsync(releaseCode: string, customTestId: number, fileReferenceId: number): DETACH_customTestAssetPreviewAction {
  return {
    type: ActionTypeDoEditor.DETACH_customTestAssetPreview,
    payload: delay(detachFileFromCustomTest(releaseCode, customTestId, fileReferenceId)),
    meta: {
      customTestId,
      assetPreviewId: fileReferenceId
    }
  }
}

