/**
 * Created by janis dähne.
 */
import {
  SET_afterEditor_hasFileChangedMapAction,
  SET_afterEditor_hasUnsavedChangesAction, SET_afterEditor_isFileExplorerDisplayedDoEditorAction,
  SET_afterEditor_isRenamingFileDoEditorAction,
  SET_afterEditor_newFileNameDoEditorAction, SET_afterEditor_renamingFileIdDoEditorAction,
  SET_afterEditor_renamingFileNameDoEditorAction,
  SET_afterEditor_selectedTabIdDoEditorAction
} from "../../../reducers/doExerciseSite/editorReducers/afterEditorReducer";
import {changeTabVisibility, HasFileChangedMap} from "../../../../helpers/editorHelper";
import {ActionType} from "../../../reducers/doExerciseSite/doExerciseSiteActionTypes";
import {SolutionFileDoExerciseFullBase} from "../../../../types/exerciseSolution";
import {MultiActions} from "../../types";
import {setAfterSolutionFiles} from "../doExerciseSiteActions";

export function setAfterEditor_hasUnsavedChanges(hasUnsavedChanges: boolean): SET_afterEditor_hasUnsavedChangesAction {
  return {
    type: ActionType.SET_afterEditor_hasUnsavedChanges,
    hasUnsavedChanges
  }
}

/**
 * sets the file changed map to determine what files changed
 *
 *
 * pass {} to indicate that no file has changed
 * @param {HasFileChangedMap} hasFileChangedMap
 * @returns {SET_hasFileChangedMapAction}
 */
export function setAfterEditor_hasFileChangedMap(hasFileChangedMap: HasFileChangedMap): SET_afterEditor_hasFileChangedMapAction {
  return {
    type: ActionType.SET_afterEditor_hasFileChangedMap,
    hasFileChangedMap
  }
}


/**
 * the file
 * @param {SolutionFileDoExerciseFullBase} file the file (won't be used to change something)
 * @param {ReadonlyArray<SolutionFileDoExerciseFullBase>} templateFiles
 * @param {number} selectedFileId
 * @returns {MultiActions}
 */
export function openTabChangeAfterEditor(file: SolutionFileDoExerciseFullBase,
                                      templateFiles: ReadonlyArray<SolutionFileDoExerciseFullBase>,
                                      selectedFileId: number): MultiActions {
  return changeTabVisibility(file, true, templateFiles, selectedFileId, setAfterSolutionFiles, setAfterEditor_selectedTabIdDoEditor)
}

export function closeTabChangeAfterEditor(file: SolutionFileDoExerciseFullBase,
                                       templateFiles: ReadonlyArray<SolutionFileDoExerciseFullBase>,
                                       selectedFileId: number): MultiActions {
  return changeTabVisibility(file, false, templateFiles, selectedFileId, setAfterSolutionFiles, setAfterEditor_selectedTabIdDoEditor)
}


export function setAfterEditor_selectedTabIdDoEditor(selectedTabIdDoEditor: number): SET_afterEditor_selectedTabIdDoEditorAction {
  return {
    type: ActionType.SET_afterEditor_selectedTabIdDoEditor,
    selectedTabIdDoEditor
  }
}

export function setAfterEditor_isFileExplorerDisplayedDoEditor(isFileExplorerDisplayedDoEditor: boolean): SET_afterEditor_isFileExplorerDisplayedDoEditorAction {
  return {
    type: ActionType.SET_afterEditor_isFileExplorerDisplayedDoEditor,
    isFileExplorerDisplayedDoEditor
  }
}

export function setAfterEditor_newFileNameDoEditor(newFileNameDoEditor: string): SET_afterEditor_newFileNameDoEditorAction {
  return {
    type: ActionType.SET_afterEditor_newFileNameDoEditor,
    newFileNameDoEditor
  }
}

export function setAfterEditor_renamingFileIdDoEditor(renamingFileIdDoEditor: number): SET_afterEditor_renamingFileIdDoEditorAction {
  return {
    type: ActionType.SET_afterEditor_renamingFileIdDoEditor,
    renamingFileIdDoEditor
  }
}

export function setAfterEditor_isRenamingFileDoEditor(isRenamingFileDoEditor: boolean): SET_afterEditor_isRenamingFileDoEditorAction {
  return {
    type: ActionType.SET_afterEditor_isRenamingFileDoEditor,
    isRenamingFileDoEditor
  }
}

export function setAfterEditor_renamingFileNameDoEditor(renamingFileNameDoEditor: string): SET_afterEditor_renamingFileNameDoEditorAction {
  return {
    type: ActionType.SET_afterEditor_renamingFileNameDoEditor,
    renamingFileNameDoEditor
  }
}