/**
 * Created by janis dähne.
 */
import {MultiActions} from "../../types";
import {ActionType} from "../../../reducers/doExerciseSite/doExerciseSiteActionTypes";
import {SET_afterCustomTestsAction} from "../../../reducers/doExerciseSite/doExerciseSiteReducer";
import {RunnableAfterCustomTestFrontendExclusive} from '../../../../types/customTests'


/**
 * sets the given tests as running and resets there results
 * @param {ReadonlyArray<RunnableAfterCustomTestFrontendExclusive>} tests
 * @param {ReadonlyArray<RunnableAfterCustomTestFrontendExclusive>} allTests
 * @returns {MultiActions}
 */
export function setAfterCustomTestsAreRunningAndResetResult(tests: ReadonlyArray<RunnableAfterCustomTestFrontendExclusive>, allTests: ReadonlyArray<RunnableAfterCustomTestFrontendExclusive>): MultiActions {
  return dispatch => {

    const copy = allTests.map<RunnableAfterCustomTestFrontendExclusive>(p => {
      return tests.some(runningTest => p.id === runningTest.id)
        ? {
          ...p,
          uiIsRunning: true,
          result: null
        }
        : p
    })

    dispatch(setAfterCustomTests(copy))
  }
}


export function setAfterCustomTests(afterCustomTests: ReadonlyArray<RunnableAfterCustomTestFrontendExclusive>): SET_afterCustomTestsAction {
  return {
    type: ActionType.SET_afterCustomTests,
    afterCustomTests
  }
}