/**
 * Created by janis dähne.
 */
import {RunnableExerciseTestFrontendExclusive} from "../../../../types/exerciseEditor";
import {MultiActions} from "../../types";
import {ActionType} from "../../../reducers/doExerciseSite/doExerciseSiteActionTypes";
import {SET_testsAction} from "../../../reducers/doExerciseSite/doExerciseReducer";
import {
  SET_afterNormalTestsAction,
  SET_afterSubmitTestsAction
} from "../../../reducers/doExerciseSite/doExerciseSiteReducer";
import {AssessedSubmitTestFrontendExclusive} from "../../../../types/testResults";


/**
 * sets the given tests as running and resets there results
 * @param {ReadonlyArray<RunnableExerciseTestFrontendExclusive>} tests
 * @param {ReadonlyArray<RunnableExerciseTestFrontendExclusive>} allTests
 * @returns {MultiActions}
 */
export function setAfterSubmitTestsAreRunningAndResetResult(tests: ReadonlyArray<AssessedSubmitTestFrontendExclusive>, allTests: ReadonlyArray<AssessedSubmitTestFrontendExclusive>): MultiActions {
  return dispatch => {

    const copy = allTests.map<AssessedSubmitTestFrontendExclusive>(p => {
      return tests.some(runningTest => p.id === runningTest.id)
        ? {
          ...p,
          uiIsRunning: true,
          result: null
        }
        : p
    })

    dispatch(setAfterSubmitTests(copy))
  }
}


export function setAfterSubmitTests(afterSubmitTests: ReadonlyArray<AssessedSubmitTestFrontendExclusive>): SET_afterSubmitTestsAction {
  return {
    type: ActionType.SET_afterSubmitTests,
    afterSubmitTests
  }
}