/**
 * Created by janis dähne.
 */
import {ActionType} from "../../../reducers/doExerciseSite/doExerciseSiteActionTypes";
import {
  CustomTestForBackend, CustomTestFromBackend,
  RunnableCustomTestFrontendExclusive
} from "../../../../types/customTests";
import {AwaitActions, MultiActions} from "../../types";
import {SET_customTestsAction} from "../../../reducers/doExerciseSite/doExerciseReducer";
import {DELETE_customTestAction} from "../../../reducers/doExerciseSite/crud/deleteCustomTestReducer";
import {delay} from "../../../../../debug";
import {deleteCustomTest} from "../../../../communicationLayer/doExerciseLayer";
import {setAfterCustomTests} from './afterCustomTestActions'


export function setCustomTestIsRunning(tests: ReadonlyArray<RunnableCustomTestFrontendExclusive>, allTests: ReadonlyArray<RunnableCustomTestFrontendExclusive>): MultiActions {
  return dispatch => {

    const copy = allTests.map<RunnableCustomTestFrontendExclusive>(p => {
      return tests.some(runningTest => p.id === runningTest.id)
        ? {
          ...p,
          uiIsRunning: true
        }
        : p
    })

    dispatch(setCustomTests(copy))
  }
}


export function setCustomTests(customTests: ReadonlyArray<RunnableCustomTestFrontendExclusive>): SET_customTestsAction {
  return {
    type: ActionType.SET_customTests,
    customTests
  }
}


export function deleteCustomTestDoEditor(releaseCode: string,
                                         customTest: CustomTestForBackend | CustomTestFromBackend,
                                         customTests: ReadonlyArray<RunnableCustomTestFrontendExclusive>): AwaitActions {
  return async (dispatch, getState) => {

    await dispatch(_deleteCustomTestDoEditor(releaseCode, customTest))

    //then remove the test from frontend
    const newCustomTests = customTests.filter(p => p.id !== customTest.id)
    dispatch(setCustomTests(newCustomTests))

  }
}

export function _deleteCustomTestDoEditor(releaseCode: string, customTest: CustomTestForBackend | CustomTestFromBackend): DELETE_customTestAction {
  return {
    type: ActionType.DELETE_customTest,
    payload: delay(deleteCustomTest(releaseCode, customTest))
  }
}