/**
 * Created by janis dähne.
 */


import {FileWithData} from "../../../../types/exerciseEditor";
import {MultiActions} from "../../types";
import {createAndRefreshAssetUrlsAndObjects} from "../../../../helpers/assetHelper";
import {
  SET_assetsAction,
  SET_contentAction
} from "../../../reducers/editCustomProjectSite/subSets/setCustomProjectDescriptionReducer";
import {ActionType} from "../../../reducers/editCustomProjectSite/editCustomProjectSiteActionTypes";


export function setDescriptionContent(content: string): SET_contentAction {
  return {
    type: ActionType.SET_content,
    content
  }
}

/**
 * sets the assets and re creates the object urls (this is better because we use this for adding, removing, loading...)
 * instead to call an additional function on different places
 * @param {ReadonlyArray<FileWithData>} assets
 * @returns {SET_assetsAction}
 */
export function setCustomProjectDescriptionAssets(assets: ReadonlyArray<FileWithData>):MultiActions  {
  return (dispatch) => {

    dispatch(_setExerciseEditorAssets(assets))

    createAndRefreshAssetUrlsAndObjects(assets)
  }
}


export function _setExerciseEditorAssets(assets: ReadonlyArray<FileWithData>):SET_assetsAction  {
  return {
    type: ActionType.SET_assets,
    assets
  }
}



