import {ActionType} from '../../reducers/globalSystemSettings/globalSystemSettingsActionTypes'
import {
  SET_clickedOnLocalServerMessageAction,
  SET_clickedOnServerMessageAction, SET_localServerMessageAction,
} from '../../reducers/globalSystemSettings/globalSystemSettingsReducer'


export function setClickedOnServerMessage(clicked = true): SET_clickedOnServerMessageAction {
  return {
    type: ActionType.SET_clickedOnServerMessage,
    clicked
  }
}

export function setClickedOnLocalServerMessage(clicked = true): SET_clickedOnLocalServerMessageAction {
  return {
    type: ActionType.SET_clickedOnLocalServerMessage,
    clicked
  }
}


/**
 * only used when we have no connection to the server to inform already logged in users
 * @param message
 * @param forceResetClickedState
 */
export function setLocalServerMessage(message: string, forceResetClickedState: boolean): SET_localServerMessageAction {
  return {
    type: ActionType.SET_localServerMessage,
    message,
    forceResetClickedState
  }
}