import {delay} from '../../../../debug'
import {
  geServerMessageFromBackend,
  getSystemSettingsFromBackend,
  getTestPublicServerSettings
} from '../../../communicationLayer/systemSettingsLayer'
import {GET_globalSystemSettingsAction} from '../../reducers/globalSystemSettings/getSystemSettingsReducer'
import {ActionType} from '../../reducers/globalSystemSettings/globalSystemSettingsActionTypes'
import {GET_serverMessageAction} from '../../reducers/globalSystemSettings/getServerMessageReducer'
import {GET_testServerPublicSettingsAction} from '../../reducers/globalSystemSettings/getTestServerPublicSettingsReducer'


export function getGlobalSystemSettingsAsync(): GET_globalSystemSettingsAction {
  return {
    type: ActionType.GET_systemSettings,
    payload: delay(getSystemSettingsFromBackend())
  }
}

export function getTestServerPublicSettingsAsync(): GET_testServerPublicSettingsAction {
  return {
    type: ActionType.GET_testServerPublicSettings,
    payload: delay(getTestPublicServerSettings(false))
  }
}

export function geGlobalServerMessageAsync(): GET_serverMessageAction {
  return {
    type: ActionType.GET_serverMessage,
    payload: delay(geServerMessageFromBackend())
  }
}
