/**
 * Created by janis dähne.
 */
import {GroupRoleWithPermissionFullBase} from "../../../../types/groupRoles";
import {AwaitActions} from "../../types";
import {CREATE_groupRoleAction} from "../../../reducers/groupRolesSite/groupRoleReducer/createGroupRoleReducer";
import {UPDATE_groupRoleAction} from "../../../reducers/groupRolesSite/groupRoleReducer/updateGroupRoleReducer";
import {ActionType} from "../../../reducers/groupRolesSite/groupRoleReducer/groupRolesDialogActionTypes";
import {delay} from "../../../../../debug";
import {create, update} from '../../../../communicationLayer/groupRolesLayer'
import {resetChangeGroupRoleDialog} from "./changeGroupRoleDialogActions";
import {setIsChangeDialogDisplayed} from "../groupRolesSiteActions";
import {getGroupRolesAsync} from "../groupRolesCrudActions";


export function createGroupRolesAsync(groupRole: GroupRoleWithPermissionFullBase): AwaitActions {
  return async (dispatch) => {

    const role = await dispatch(_createGroupRolesAsync(groupRole))
    dispatch(getGroupRolesAsync())
    dispatch(setIsChangeDialogDisplayed(false))
    dispatch(resetChangeGroupRoleDialog())

  }
}

function _createGroupRolesAsync(groupRole: GroupRoleWithPermissionFullBase): CREATE_groupRoleAction {
  return {
    type: ActionType.CREATE_groupRole,
    payload: delay(create(groupRole))
  }
}

export function updateGroupRolesAsync(groupRole: GroupRoleWithPermissionFullBase): AwaitActions {
  return async (dispatch) => {

    const role = await dispatch(_updateGroupRolesAsync(groupRole))
    dispatch(getGroupRolesAsync())
    dispatch(setIsChangeDialogDisplayed(false))
    dispatch(resetChangeGroupRoleDialog())
  }
}

function _updateGroupRolesAsync(groupRole: GroupRoleWithPermissionFullBase): UPDATE_groupRoleAction {
  return {
    type: ActionType.UPDATE_groupRole,
    payload: delay(update(groupRole))
  }
}