import {CREATE_langAction} from '../../reducers/langsView/crud/createLangReducer'
import {LangFullBase} from '../../../types/languages'
import {ActionType} from '../../reducers/langsView/langsViewActionTypes'
import {delay} from '../../../../debug'
import {UPDATE_langAction} from '../../reducers/langsView/crud/updateLangReducer'
import {DELETE_langAction} from '../../reducers/langsView/crud/deleteLangReducer'
import {createLang, deleteLang, getLanguages, updateLang} from '../../../communicationLayer/langsLayer'
import {GET_languagesAction} from '../../reducers/langsView/crud/getLangsReducer'


export function getLangsAsync(): GET_languagesAction {
  return {
    type: ActionType.GET_languages,
    payload: delay(getLanguages())
  }
}

export function createLangAsync(lang: LangFullBase): CREATE_langAction {
  return {
    type: ActionType.CREATE_lang,
    payload: delay(createLang(lang))
  }
}


export function updateLangAsync(lang: LangFullBase): UPDATE_langAction {
  return {
    type: ActionType.UPDATE_lang,
    payload: delay(updateLang(lang))
  }
}

export function deleteLangAsync(lang: LangFullBase): DELETE_langAction {
  return {
    type: ActionType.DELETE_lang,
    payload: delay(deleteLang(lang.id)),
    meta: {
      langId: lang.id
    }
  }
}
