import {
  SET_editingLangIdAction,
  SET_Lang_displayNameAction,
  SET_Lang_langShortcutAction
} from '../../reducers/langsView/langsViewReducer'
import {ActionType} from '../../reducers/langsView/langsViewActionTypes'


/**
 * sets the lang to edit and creates a copy of it for editing
 * @param editingLangId use <= 0 to indicate to create a new lang (and use the new id as editingLangId),
 *  use null to clear editing, crud (create/update) operations should clear the edit too
 */
export function setEditingLangId(editingLangId: number | null): SET_editingLangIdAction {
  return {
    type: ActionType.SET_editingLangId,
    editingLangId
  }
}


export function setLangDisplayName(displayName: string): SET_Lang_displayNameAction {
  return {
    type: ActionType.SET_Lang_displayName,
    displayName
  }
}

export function setLangShortcut(langShortcut: string): SET_Lang_langShortcutAction {
  return {
    type: ActionType.SET_Lang_langShortcut,
    langShortcut
  }
}
