/**
 * Created by janis dähne.
 */

import {Action} from "redux";
import {
  LoginActionReset,
  LoginActionSetId,
  LoginActionSetPw,
  ActionType,
  SET_isLoggingInAction,
  SET_isCheckingAlreadyLoggedInAction,
  SET_isRegisterFormDisplayedAction,
  SET_registerTokenAction,
  SET_registerPwAction,
  SET_registerFirstNameAction,
  SET_registerLastNameAction,
  SET_registerEmailAction,
  SET_registerPwAgainAction,
  SET_isRegisteringAction,
  SET_beforeLoginErrorMessageAction
} from "../reducers/loginReducer";

//import {createAction} from 'redux-actions';
//does not work...
// const act = createAction<string>(ActionType.SET_systemRoles)
// act('a')



//--- register actions

export function setIsRegisterFormDisplayed(isRegisterFormDisplayed: boolean): SET_isRegisterFormDisplayedAction {
  return {
    type: ActionType.SET_isRegisterFormDisplayed,
    isRegisterFormDisplayed
  }
}
export function setIsRegistering(isRegistering: boolean): SET_isRegisteringAction {
  return {
    type: ActionType.SET_isRegistering,
    isRegistering
  }
}

export function setRegisterToken(registerToken: string): SET_registerTokenAction {
  return {
    type: ActionType.SET_registerToken,
    registerToken
  }
}

export function setRegisterPw(registerPw: string): SET_registerPwAction {
  return {
    type: ActionType.SET_registerPw,
    registerPw
  }
}
export function setRegisterPwAgain(registerPwAgain: string): SET_registerPwAgainAction {
  return {
    type: ActionType.SET_registerPwAgain,
    registerPwAgain
  }
}


export function setRegisterFirstName(registerFirstName: string): SET_registerFirstNameAction {
  return {
    type: ActionType.SET_registerFirstName,
    registerFirstName
  }
}

export function setRegisterLastName(registerLastName: string): SET_registerLastNameAction {
  return {
    type: ActionType.SET_registerLastName,
    registerLastName
  }
}

export function setRegisterEmail(registerEmail: string): SET_registerEmailAction {
  return {
    type: ActionType.SET_registerEmail,
    registerEmail
  }
}


//--- login actions

/**
 * should set the username
 * @param {string} id
 * @returns {LoginActionSetId}
 */
export function setUsername(id: string): LoginActionSetId {
  return {
    type: ActionType.SET_USERNAME,
    id
  }
}

/**
 * should set the password
 * @param {string} pw
 * @returns {LoginActionSetPw}
 */
export function setPassword(pw: string): LoginActionSetPw {
  return {
    type: ActionType.SET_PASSWORD,
    pw
  }
}

export function setIsLoggingIn(isLogginIn: boolean): SET_isLoggingInAction {
  return {
    type: ActionType.SET_isLoggingIn,
    isLoggingIn: isLogginIn
  }
}

export function setIsCheckingAlreadyLoggedIn(isCheckingAlreadyLoggedIn: boolean): SET_isCheckingAlreadyLoggedInAction {
  return {
    type: ActionType.SET_isCheckingAlreadyLoggedIn,
    isCheckingAlreadyLoggedIn
  }
}

export function setBeforeLoginErrorMessage(errorMessage: string): SET_beforeLoginErrorMessageAction {
  return {
    type: ActionType.SET_beforeLoginErrorMessage,
    errorMessage
  }
}


/**
 * should reset username and password
 * @returns {LoginActionReset}
 */
export function reset(): LoginActionReset {
  return {
    type: ActionType.RESET
  }
}