/**
 * Created by janis dähne.
 */
import {
  SET_descriptionAction,
  SET_displayNameAction,
  SET_htmlBackgroundColorAction,
  SET_htmlColorAction,
  SET_htmlIconAction,
  SET_idAction
} from "../../../reducers/manageTagsSite/dialog/tagReducer";
import {ActionType} from "../../../reducers/manageTagsSite/dialog/changeTagDialogActionTypes";
import {TagFullBase} from "../../../../types/tag";
import {MultiActions} from "../../types";


export function setTargetTag(tag: TagFullBase): MultiActions {
  return (dispatch) => {
    dispatch(setId(tag.id))
    dispatch(setDisplayName(tag.displayName))

    dispatch(setDescription(tag.description))
    dispatch(setHtmlColor(tag.htmlColor))
    dispatch(setHtmlBackgroundColor(tag.htmlBackgroundColor))
    dispatch(setHtmlIcon(tag.htmlIcon))

  }
}

export function setId(id: number): SET_idAction {
  return {
    type: ActionType.SET_id,
    id
  }
}

export function setDisplayName(displayName: string): SET_displayNameAction {
  return {
    type: ActionType.SET_displayName,
    displayName
  }
}

export function setDescription(description: string): SET_descriptionAction {
  return {
    type: ActionType.SET_description,
    description
  }
}

export function setHtmlColor(htmlColor: string): SET_htmlColorAction {
  return {
    type: ActionType.SET_htmlColor,
    htmlColor
  }
}

export function setHtmlBackgroundColor(htmlBackgroundColor: string): SET_htmlBackgroundColorAction {
  return {
    type: ActionType.SET_htmlBackgroundColor,
    htmlBackgroundColor
  }
}

export function setHtmlIcon(htmlIcon: string): SET_htmlIconAction {
  return {
    type: ActionType.SET_htmlIcon,
    htmlIcon
  }
}
