/**
 * Created by janis dähne.
 */
import {ActionType} from "../../../reducers/ownOrGroupExerciseReducers/exerciseReleasesSite/releasesSiteActionTypes";
import {GET_exerciseReleasesAction} from "../../../reducers/ownOrGroupExerciseReducers/exerciseReleasesSite/getReleasesReducer";
import {delay} from "../../../../../debug";
import {deleteExerciseRelease, getForExercise} from "../../../../communicationLayer/exerciseReleasesLayer";
import {DELETE_exerciseReleaseAction} from "../../../reducers/ownOrGroupExerciseReducers/exerciseReleasesSite/deleteReleaseReducer";
import {PaginationPostData} from '../../../../types/pagination'
import {MultiActions} from '../../types'
import {PaginationHelper} from '../../../../helpers/paginationHelper'
import {GET_singleOwnExerciseAction} from '../../../reducers/ownOrGroupExerciseReducers/exerciseReleasesSite/getSingleOwnExerciseCrudReducer'
import {
  getSingleGroupExercisePreview,
  getSingleOwnExercisePreview
} from '../../../../communicationLayer/exercisesOverviewLayer'
import {GET_singleGroupExerciseAction} from '../../../reducers/ownOrGroupExerciseReducers/exerciseReleasesSite/getSingleGroupExerciseCrudReducer'


export function _getExerciseReleaseAsync(exerciseId: number, paginationPostData: PaginationPostData): GET_exerciseReleasesAction {
  return {
    type: ActionType.GET_exerciseReleases,
    payload: delay(getForExercise(exerciseId, paginationPostData)),
  }
}

export function getExerciseReleaseAsync(): MultiActions {
  return (dispatch, getState) => {

    const exerciseId = getState().releaseSiteState.selectedExerciseId
    const postData = PaginationHelper.getPaginationPostData(getState().releaseSiteState.pagination)
    dispatch(_getExerciseReleaseAsync(exerciseId,postData))

  }
}

export function deleteExerciseReleaseAsync(releaseId: number): DELETE_exerciseReleaseAction {
  return {
    type: ActionType.DELETE_exerciseRelease,
    payload: delay(deleteExerciseRelease(releaseId)),
  }
}



export function getSingleOwnExerciseAsync(exerciseId: number): GET_singleOwnExerciseAction {
  return {
    type: ActionType.GET_singleOwnExercise,
    payload: delay(getSingleOwnExercisePreview(exerciseId)),
  }
}

export function getSingleGroupExerciseAsync(exerciseId: number): GET_singleGroupExerciseAction {
  return {
    type: ActionType.GET_singleGroupExercise,
    payload: delay(getSingleGroupExercisePreview(exerciseId)),
  }
}