/**
 * Created by janis dähne.
 */

import {ActionType} from "../../reducers/settingsSite/settingsSiteActionTypes";
import {GET_userDataAction} from "../../reducers/settingsSite/getUserDataAndSettingsReducer";
import {delay} from "../../../../debug";
import {getUserData} from "../../../communicationLayer/loginLayer";
import {UPDATE_userDataAction} from "../../reducers/settingsSite/updateUserDataReducer";
import {createOrUpdateUserSettings} from "../../../communicationLayer/userSettingsLayer";
import {EmailAndPasswordTuple, UserSettingsFullBase} from "../../../types/userData";
import {UPDATE_userSettingsAction} from "../../reducers/settingsSite/updateUserSettingsReducer";
import {updateOwnUserData} from "../../../communicationLayer/usersLayer";
import {GET_languagesAction} from "../../reducers/langsView/crud/getLangsReducer";
import {getLanguages} from "../../../communicationLayer/langsLayer";


export function getUserSettingsAndDataAsync(): GET_userDataAction {
  return {
    type: ActionType.GET_userData,
    payload: delay(getUserData())
  }
}


export function updateUserDataAsync(tuple: EmailAndPasswordTuple): UPDATE_userDataAction {
  return {
    type: ActionType.UPDATE_userData,
    payload: delay(updateOwnUserData(tuple))
  }
}


export function updateUserSettingsAsync(settings: UserSettingsFullBase): UPDATE_userSettingsAction {
  return {
    type: ActionType.UPDATE_userSettings,
    payload: delay(createOrUpdateUserSettings(settings))
  }
}


