/**
 * Created by janis dähne.
 */

import {
  UPDATE_systemRoleAction
} from "../../../reducers/systemRolesSite/dialog/updateSystemRoleReducer";
import {delay} from "../../../../../debug";
import {create, deleteEntity, update} from "../../../../communicationLayer/systemRolesLayer";
import {SystemRoleFullBase} from "../../../../types/userData";
import {
  DELETE_systemRoleAction
} from "../../../reducers/systemRolesSite/deleteSystemRoleReducer";
import {
  CREATE_systemRoleAction
} from "../../../reducers/systemRolesSite/dialog/createSystemRoleReducer";
import {ActionType} from "../../../reducers/systemRolesSite/dialog/changeSystemRoleDIalogActionTypes";
import {setIsChangeDialogDisplayed} from "../systemRolesSiteActions";
import {resetChangeSystemRoleDialog} from "./changeSystemRolesDialogActions";
import {AwaitActions} from "../../types";
import {getSystemRolesAsync} from "../systemRolesCrudActions";


export function createSystemRoleAsync(systemRole: SystemRoleFullBase): AwaitActions {
  return async (dispatch) => {

    const role = await dispatch(_createSystemRoleAsync(systemRole))
    dispatch(getSystemRolesAsync()) //refresh system roles site
    dispatch(setIsChangeDialogDisplayed(false))
    dispatch(resetChangeSystemRoleDialog())

  }
}

function _createSystemRoleAsync(systemRole: SystemRoleFullBase): CREATE_systemRoleAction {
  return {
    type: ActionType.CREATE_systemRole,
    payload: delay(create(systemRole))
  }
}

export function updateSystemRoleAsync(systemRole: SystemRoleFullBase): AwaitActions {
  return async (dispatch) => {

    await dispatch(_updateSystemRoleAsync(systemRole))
    dispatch(getSystemRolesAsync()) //refresh system roles site
    dispatch(setIsChangeDialogDisplayed(false))
    dispatch(resetChangeSystemRoleDialog())
  }
}

function _updateSystemRoleAsync(systemRole: SystemRoleFullBase): UPDATE_systemRoleAction {
  return {
    type: ActionType.UPDATE_systemRole,
    payload: delay(update(systemRole))
  }
}


