/**
 * Created by janis dähne.
 */

import {SystemRoleFullBase} from "../../../types/userData";
import {
  ResetAction, SET_isChangeDialogDisplayedAction,
  SetListAction
} from "../../reducers/systemRolesSite/systemRolesSiteReducer";
import {ActionType} from "../../reducers/systemRolesSite/systemRolesSiteActionTypes";
import {ThunkAction} from "redux-thunk";
import {setIsCreating, resetChangeSystemRoleDialog} from "./dialog/changeSystemRolesDialogActions";
import {setTargetSystemRole} from "./dialog/systemRoleSetActions";
import {AwaitActions, MultiActions} from "../types";
import {getNotLockedSystemRoleIdsAsync, getSystemRolesAsync} from "./systemRolesCrudActions";


export function setSystemRoles(systemRoles: ReadonlyArray<SystemRoleFullBase>): SetListAction {
  return {
    type: ActionType.SET_systemRoles,
    systemRoles: systemRoles
  }
}

export function openCreateSystemRoleDialog(): MultiActions {
  return dispatch => {

    dispatch(resetChangeSystemRoleDialog())
    dispatch(setIsCreating(true))
    dispatch(setIsChangeDialogDisplayed(true))
  }
}

export function openEditSystemRoleDialog(systemRole: SystemRoleFullBase): MultiActions {
  return dispatch => {

    dispatch(resetChangeSystemRoleDialog())
    dispatch(setIsCreating(false))
    dispatch(setTargetSystemRole(systemRole))
    dispatch(setIsChangeDialogDisplayed(true))

  }
}

export function cancelEditSystemRole(): MultiActions {
  return dispatch => {

    dispatch(setIsChangeDialogDisplayed(false))
    dispatch(resetChangeSystemRoleDialog())

  }
}

export function setIsChangeDialogDisplayed(isDisplayed: boolean): SET_isChangeDialogDisplayedAction {
  return {
    type: ActionType.SET_isChangeDialogDisplayed,
    isDisplayed
  }
}

export function loadSystemRolesSite(): AwaitActions {
  return async (dispatch, getState) => {

    dispatch(resetSystemRolesSite())

    await dispatch(getNotLockedSystemRoleIdsAsync())

    await dispatch(getSystemRolesAsync())
  }
}

export function resetSystemRolesSite(): ResetAction {
  return {
    type: ActionType.RESET
  }
}
