/**
 * Created by janis dähne.
 */
import {changeTabVisibility, getNewActiveTabId, HasFileChangedMap} from "../../../../helpers/editorHelper";
import {MultiActions} from "../../types";
import {
  SET_tutorEditor_hasFileChangedMapAction,
  SET_tutorEditor_hasUnsavedChangesAction, SET_tutorEditor_isFileExplorerDisplayedDoEditorAction,
  SET_tutorEditor_isRenamingFileDoEditorAction,
  SET_tutorEditor_newFileNameDoEditorAction, SET_tutorEditor_renamingFileIdDoEditorAction,
  SET_tutorEditor_renamingFileNameDoEditorAction,
  SET_tutorEditor_selectedTabIdDoEditorAction
} from "../../../reducers/tutorViewSite/editorReducer/tutorEditorReducer";
import {SolutionFileDoExerciseFullBase} from "../../../../types/exerciseSolution";
import {ActionType} from "../../../reducers/tutorViewSite/tutorViewSiteActionTypes";
import {
  setSolutionFilesCodeTemplateTutorView,
  setSolutionFilesTutorEditor,
  setSolutionFilesUserAfterSolutionTutorView
} from "../tutorViewSiteActions";
import {
  SET_afterSolutionEditor_isFileExplorerDisplayedDoEditorAction,
  SET_afterSolutionEditor_selectedTabIdDoEditorAction
} from '../../../reducers/tutorViewSite/editorReducer/userAfterSolutionTutorViewEditorReducer'
import {
  SET_codeTemplateEditor_isFileExplorerDisplayedDoEditorAction,
  SET_codeTemplateEditor_selectedTabIdDoEditorAction
} from '../../../reducers/tutorViewSite/editorReducer/codeTemplateTutorViewEditorReducer'
import {ExerciseCodeTemplateFileFullBase} from '../../../../types/exerciseEditor'
import {setSelectedTabIdAfterEditorTutorView} from './userAfterSolutionEditorTutorActions'


export function openTabChangeCodeTemplateEditorTutorView(file: ExerciseCodeTemplateFileFullBase,
                                                         templateFiles: ReadonlyArray<ExerciseCodeTemplateFileFullBase>,
                                                         selectedFileId: number,
                                                         codeTemplateId: number
): MultiActions {
  return changeTabVisibility(file, true, templateFiles, selectedFileId, setSolutionFilesCodeTemplateTutorView.bind(null, codeTemplateId),
                             setSelectedTabIdCodeTemplateEditorTutorView
  )
}

export function closeTabChangeCodeTemplateEditorTutorView(file: ExerciseCodeTemplateFileFullBase,
                                                          templateFiles: ReadonlyArray<ExerciseCodeTemplateFileFullBase>,
                                                          selectedFileId: number,
                                                          codeTemplateId: number
): MultiActions {
  return changeTabVisibility(file, false, templateFiles, selectedFileId, setSolutionFilesCodeTemplateTutorView.bind(null, codeTemplateId),
                             setSelectedTabIdCodeTemplateEditorTutorView
  )
}

export function setSelectedTabIdCodeTemplateEditorTutorView(selectedTabIdDoEditor: number): SET_codeTemplateEditor_selectedTabIdDoEditorAction {
  return {
    type: ActionType.SET_codeTemplateEditor_selectedTabIdDoEditor,
    selectedTabIdDoEditor
  }
}

export function setIsFileExplorerDisplayedCodeTemplateEditorTutorView(isFileExplorerDisplayedDoEditor: boolean): SET_codeTemplateEditor_isFileExplorerDisplayedDoEditorAction {
  return {
    type: ActionType.SET_codeTemplateEditor_isFileExplorerDisplayedDoEditor,
    isFileExplorerDisplayedDoEditor
  }
}

