/**
 * Created by janis dähne.
 */
import {changeTabVisibility, HasFileChangedMap} from "../../../../helpers/editorHelper";
import {MultiActions} from "../../types";
import {
  SET_tutorEditor_hasFileChangedMapAction,
  SET_tutorEditor_hasUnsavedChangesAction, SET_tutorEditor_isFileExplorerDisplayedDoEditorAction,
  SET_tutorEditor_isRenamingFileDoEditorAction,
  SET_tutorEditor_newFileNameDoEditorAction, SET_tutorEditor_renamingFileIdDoEditorAction,
  SET_tutorEditor_renamingFileNameDoEditorAction,
  SET_tutorEditor_selectedTabIdDoEditorAction
} from "../../../reducers/tutorViewSite/editorReducer/tutorEditorReducer";
import {SolutionFileDoExerciseFullBase} from "../../../../types/exerciseSolution";
import {ActionType} from "../../../reducers/tutorViewSite/tutorViewSiteActionTypes";
import {setSolutionFilesTutorEditor, setSolutionFilesUserAfterSolutionTutorView} from "../tutorViewSiteActions";
import {
  SET_afterSolutionEditor_isFileExplorerDisplayedDoEditorAction,
  SET_afterSolutionEditor_selectedTabIdDoEditorAction
} from '../../../reducers/tutorViewSite/editorReducer/userAfterSolutionTutorViewEditorReducer'



/**
 * the file
 * @param {SolutionFileDoExerciseFullBase} file the file (won't be used to change something)
 * @param {ReadonlyArray<SolutionFileDoExerciseFullBase>} templateFiles
 * @param {number} selectedFileId the currently selected file id
 * @returns {MultiActions}
 */
export function openTabChangeAfterEditorTutorView(file: SolutionFileDoExerciseFullBase,
                                         templateFiles: ReadonlyArray<SolutionFileDoExerciseFullBase>,
                                         selectedFileId: number): MultiActions {
  return changeTabVisibility(file, true, templateFiles, selectedFileId, setSolutionFilesUserAfterSolutionTutorView,
                             setSelectedTabIdAfterEditorTutorView)
}

export function closeTabChangeAfterEditorTutorView(file: SolutionFileDoExerciseFullBase,
                                          templateFiles: ReadonlyArray<SolutionFileDoExerciseFullBase>,
                                          selectedFileId: number): MultiActions {
  return changeTabVisibility(file, false, templateFiles, selectedFileId, setSolutionFilesUserAfterSolutionTutorView,
                             setSelectedTabIdAfterEditorTutorView)
}

export function setSelectedTabIdAfterEditorTutorView(selectedTabIdDoEditor: number): SET_afterSolutionEditor_selectedTabIdDoEditorAction {
  return {
    type: ActionType.SET_afterSolutionEditor_selectedTabIdDoEditor,
    selectedTabIdDoEditor
  }
}

export function setIsFileExplorerDisplayedAfterEditorTutorView(isFileExplorerDisplayedDoEditor: boolean): SET_afterSolutionEditor_isFileExplorerDisplayedDoEditorAction {
  return {
    type: ActionType.SET_afterSolutionEditor_isFileExplorerDisplayedDoEditor,
    isFileExplorerDisplayedDoEditor
  }
}

