/**
 * Created by janis dähne.
 */
import {RunnableExerciseTestFrontendExclusive} from "../../../../types/exerciseEditor";
import {SET_normalTestsForTutorAction} from "../../../reducers/tutorViewSite/tutorViewSiteReducer";
import {ActionType} from "../../../reducers/tutorViewSite/tutorViewSiteActionTypes";
import {MultiActions} from "../../types";


/**
 * sets the given tests as running and resets there results
 * @param {ReadonlyArray<RunnableExerciseTestFrontendExclusive>} tests
 * @param {ReadonlyArray<RunnableExerciseTestFrontendExclusive>} allTests
 * @returns {MultiActions}
 */
export function setNormalTestsForTutorAreRunningAndResetResult(tests: ReadonlyArray<RunnableExerciseTestFrontendExclusive>, allTests: ReadonlyArray<RunnableExerciseTestFrontendExclusive>): MultiActions {
  return dispatch => {

    const copy = allTests.map<RunnableExerciseTestFrontendExclusive>(p => {
      return tests.some(runningTest => p.id === runningTest.id)
        ? {
          ...p,
          uiIsRunning: true,
          result: null
        }
        : p
    })

    dispatch(setNormalTestsForTutor(copy))
  }
}

export function setNormalTestsForTutor(testsForTutor: ReadonlyArray<RunnableExerciseTestFrontendExclusive>): SET_normalTestsForTutorAction {
  return {
    type: ActionType.SET_normalTestsForTutor,
    testsForTutor
  }
}