import {ActionBase, ActionType} from '../dashboardSiteActionTypes'
import {initial, State} from '../dashboardSiteReducer'
import {ReduxPromiseRejectedAction, ReduxPromiseAction, ReduxPromiseFulfilledAction} from '../../index'
import {notExhaustive} from '../../_notExhausiveHelper'
import {ClientServerConstants} from '../../../../types/dashboard'



export interface GET_clientServerConstantsAction
  extends ActionBase, ReduxPromiseAction<ClientServerConstants, GET_clientServerConstants_PENDINGAction, GET_clientServerConstants_FULFILLEDAction, GET_clientServerConstants_REJECTEDAction> {
  readonly type: ActionType.GET_clientServerConstants
  readonly payload: Promise<ClientServerConstants>
}

//automatically dispatched by redux promise middleware
export interface GET_clientServerConstants_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_clientServerConstants_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_clientServerConstants_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<ClientServerConstants> {
  readonly type: ActionType.GET_clientServerConstants_FULFILLED
  readonly payload: ClientServerConstants
}

//automatically dispatched by redux promise middleware
export interface GET_clientServerConstants_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_clientServerConstants_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_clientServerConstants_PENDINGAction
  | GET_clientServerConstants_FULFILLEDAction
  | GET_clientServerConstants_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_clientServerConstants_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_clientServerConstants_FULFILLED:
      return {
        ...state,
        isLoading: false,
        clientServerConstants: action.payload
      }
    case ActionType.GET_clientServerConstants_REJECTED:
      return {
        ...state,
        isLoading: false,
        clientServerConstants: null
      }

    default:
      notExhaustive(action)
      return state
  }
}

