/**
 * Created by janis dähne.
 */

import {SolutionFileDoExerciseFullBase, SolutionDoExerciseFullBase} from "../../../../types/exerciseSolution";
import moment from "moment";
import {ActionBase, ActionType} from "../doExerciseSiteActionTypes";
import {notExhaustive} from "../../_notExhausiveHelper";
import {FrontendSettingsManager} from "../../../../helpers/frontendSettingsManager";

export type State = SolutionDoExerciseFullBase


export const initial: State = {
  pLangId: -1,
  mainFileId: -1,
  note: '',
  lastUpdatedAt: moment(),
  solutionFiles: [],
  shouldNotCount: false,
  userId: -1,
  releaseId: -1,
  shouldLoadAfterSolution: false,
  hasLoadAfterSolution: false
}


export interface SET_solutionFilesAction extends ActionBase {
  readonly type: ActionType.SET_solutionFiles
  readonly solutionFiles: ReadonlyArray<SolutionFileDoExerciseFullBase>
}

export interface SET_mainFileIdAction extends ActionBase {
  readonly type: ActionType.SET_mainFileId
  readonly mainFileId: number
}


export type AllActions =
  | SET_solutionFilesAction
  | SET_mainFileIdAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_solutionFiles:
      return {
        ...state,
        solutionFiles: action.solutionFiles
      }

    case ActionType.SET_mainFileId:
      return {
        ...state,
        mainFileId: action.mainFileId
      }

    default:
      notExhaustive(action)
      return state
  }
}

