/**
 * Created by janis dähne.
 */

import {ActionBase, ActionType} from "../editCustomProjectSiteActionTypes";
import {State, initial} from "../editCustomProjectSiteReducer";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {notExhaustive} from "../../_notExhausiveHelper";


export interface UPDATE_customProjectPropertiesAction
  extends ActionBase, ReduxPromiseAction<void, UPDATE_customProjectProperties_PENDINGAction, UPDATE_customProjectProperties_FULFILLEDAction, UPDATE_customProjectProperties_REJECTEDAction> {
  readonly type: ActionType.UPDATE_customProjectProperties
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface UPDATE_customProjectProperties_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.UPDATE_customProjectProperties_PENDING
}

//automatically dispatched by redux promise middleware
export interface UPDATE_customProjectProperties_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.UPDATE_customProjectProperties_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface UPDATE_customProjectProperties_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.UPDATE_customProjectProperties_REJECTED
  readonly payload: any
}


export type AllActions =
  UPDATE_customProjectProperties_PENDINGAction
  | UPDATE_customProjectProperties_FULFILLEDAction
  | UPDATE_customProjectProperties_REJECTEDAction


export function reducer(state: State = initial(), action: AllActions): State {

  switch (action.type) {

    case ActionType.UPDATE_customProjectProperties_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.UPDATE_customProjectProperties_FULFILLED:
      return {
        ...state,
        isLoading: false
      }
    case ActionType.UPDATE_customProjectProperties_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

