/**
 * Created by janis dähne.
 */
import {Action} from "redux";


export interface ActionBase extends Action {
  readonly type: ActionType
}


export enum ActionType {


  //---sub sets

  SET_content = 'customProjectsSite_SET_content',
  SET_assets = 'customProjectsSite_SET_assets',

  SET_initialPLangId = 'customProjectsSite_SET_initialPLangId',

  SET_solutionFiles = 'customProjectsSite_SET_solutionFiles',
  SET_mainFileId = 'customProjectsSite_SET_mainFileId',

  JUST_RUN_program = 'customProjectsSite_JUST_RUN_program',
  JUST_RUN_program_PENDING = 'customProjectsSite_JUST_RUN_program_PENDING',
  JUST_RUN_program_FULFILLED = 'customProjectsSite_JUST_RUN_program_FULFILLED',
  JUST_RUN_program_REJECTED = 'customProjectsSite_JUST_RUN_program_REJECTED',

  CREATE_customProject = 'customProjectsSite_CREATE_customProject',
  CREATE_customProject_PENDING = 'customProjectsSite_CREATE_customProject_PENDING',
  CREATE_customProject_FULFILLED = 'customProjectsSite_CREATE_customProject_FULFILLED',
  CREATE_customProject_REJECTED = 'customProjectsSite_CREATE_customProject_REJECTED',

  GET_customProject = 'customProjectsSite_GET_customProject',
  GET_customProject_PENDING = 'customProjectsSite_GET_customProject_PENDING',
  GET_customProject_FULFILLED = 'customProjectsSite_GET_customProject_FULFILLED',
  GET_customProject_REJECTED = 'customProjectsSite_GET_customProject_REJECTED',

  UPDATE_customProjectSolution = 'customProjectsSite_UPDATE_customProjectSolution',
  UPDATE_customProjectSolution_PENDING = 'customProjectsSite_UPDATE_customProjectSolution_PENDING',
  UPDATE_customProjectSolution_FULFILLED = 'customProjectsSite_UPDATE_customProjectSolution_FULFILLED',
  UPDATE_customProjectSolution_REJECTED = 'customProjectsSite_UPDATE_customProjectSolution_REJECTED',

  UPDATE_customProjectDescription = 'customProjectsSite_UPDATE_customProjectDescription',
  UPDATE_customProjectDescription_PENDING = 'customProjectsSite_UPDATE_customProjectDescription_PENDING',
  UPDATE_customProjectDescription_FULFILLED = 'customProjectsSite_UPDATE_customProjectDescription_FULFILLED',
  UPDATE_customProjectDescription_REJECTED = 'customProjectsSite_UPDATE_customProjectDescription_REJECTED',

  DELETE_customProjectTest = 'customProjectsSite_DELETE_customProjectTest',
  DELETE_customProjectTest_PENDING = 'customProjectsSite_DELETE_customProjectTest_PENDING',
  DELETE_customProjectTest_FULFILLED = 'customProjectsSite_DELETE_customProjectTest_FULFILLED',
  DELETE_customProjectTest_REJECTED = 'customProjectsSite_DELETE_customProjectTest_REJECTED',

  GET_customProjectTestResults = 'customProjectsSite_GET_customProjectTestResults',
  GET_customProjectTestResults_PENDING = 'customProjectsSite_GET_customProjectTestResults_PENDING',
  GET_customProjectTestResults_FULFILLED = 'customProjectsSite_GET_customProjectTestResults_FULFILLED',
  GET_customProjectTestResults_REJECTED = 'customProjectsSite_GET_customProjectTestResults_REJECTED',

  UPDATE_customProjectProperties = 'customProjectsSite_UPDATE_customProjectProperties',
  UPDATE_customProjectProperties_PENDING = 'customProjectsSite_UPDATE_customProjectProperties_PENDING',
  UPDATE_customProjectProperties_FULFILLED = 'customProjectsSite_UPDATE_customProjectProperties_FULFILLED',
  UPDATE_customProjectProperties_REJECTED = 'customProjectsSite_UPDATE_customProjectProperties_REJECTED',

  RUN_customProjectTest = 'customProjectsSite_RUN_customProjectTest',
  RUN_customProjectTest_PENDING = 'customProjectsSite_RUN_customProjectTest_PENDING',
  RUN_customProjectTest_FULFILLED = 'customProjectsSite_RUN_customProjectTest_FULFILLED',
  RUN_customProjectTest_REJECTED = 'customProjectsSite_RUN_customProjectTest_REJECTED',

  RUN_compileSingleFileCustomProject = 'customProjectsSite_RUN_compileSingleFileCustomProject',
  RUN_compileSingleFileCustomProject_PENDING = 'customProjectsSite_RUN_compileSingleFileCustomProject_PENDING',
  RUN_compileSingleFileCustomProject_FULFILLED = 'customProjectsSite_RUN_compileSingleFileCustomProject_FULFILLED',
  RUN_compileSingleFileCustomProject_REJECTED = 'customProjectsSite_RUN_compileSingleFileCustomProject_REJECTED',

  SET_topRightSelectedTabIndex = 'customProjectsSite_SET_topRightSelectedTabIndex',
  SET_topLeftSelectedTabIndex = 'customProjectsSite_SET_topLeftSelectedTabIndex',
  SET_bottomRightSelectedTabIndex = 'customProjectsSite_SET_bottomRightSelectedTabIndex',
  SET_bottomLeftSelectedTabIndex = 'customProjectsSite_SET_bottomLeftSelectedTabIndex',

  SET_topRightPanelViewSize = 'customProjectsSite_SET_topRightPanelViewSize',
  SET_topLeftPanelViewSize = 'customProjectsSite_SET_topLeftPanelViewSize',
  SET_botRightPanelViewSize = 'customProjectsSite_SET_botRightPanelViewSize',
  SET_botLeftPanelViewSize = 'customProjectsSite_SET_botLeftPanelViewSize',

  SET_hDividerPosOffset = 'customProjectsSite_SET_hDividerPosOffset',
  SET_vDividerPosOffset = 'customProjectsSite_SET_vDividerPosOffset',

  SET_isChangeTestDialogDisplayed = 'customProjectsSite_SET_isChangeTestDialogDisplayed',
  SET_isCustomProjectCodeEditorSettingsDialogDisplayed = 'customProjectsSite_SET_isCustomProjectCodeEditorSettingsDialogDisplayed',


  SET_selectedConsoleViewTest = 'customProjectsSite_SET_selectedConsoleViewTest',

  //--- custom project description (markdown)

  SET_isAddCustomProjectAssetFilesModalDisplayed = 'customProjectsSite_SET_isAddCustomProjectAssetFilesModalDisplayed',
  SET_addCustomProjectAssetFilesModalFilterText = 'customProjectsSite_SET_addCustomProjectAssetFilesModalFilterText',
  SET_addCustomProjectAssetFilesModalUploadPercentage = 'customProjectsSite_SET_addCustomProjectAssetFilesModalUploadPercentage',

  LOAD_customProjectMarkdownAsset = 'customProjectsSite_LOAD_customProjectMarkdownAsset',
  LOAD_customProjectMarkdownAsset_PENDING = 'customProjectsSite_LOAD_customProjectMarkdownAsset_PENDING',
  LOAD_customProjectMarkdownAsset_FULFILLED = 'customProjectsSite_LOAD_customProjectMarkdownAsset_FULFILLED',
  LOAD_customProjectMarkdownAsset_REJECTED = 'customProjectsSite_LOAD_customProjectMarkdownAsset_REJECTED',

  ATTACH_customProjectMarkdownAssetPreview = 'customProjectsSite_ATTACH_customProjectMarkdownAssetPreview',
  ATTACH_customProjectMarkdownAssetPreview_PENDING = 'customProjectsSite_ATTACH_customProjectMarkdownAssetPreview_PENDING',
  ATTACH_customProjectMarkdownAssetPreview_FULFILLED = 'customProjectsSite_ATTACH_customProjectMarkdownAssetPreview_FULFILLED',
  ATTACH_customProjectMarkdownAssetPreview_REJECTED = 'customProjectsSite_ATTACH_customProjectMarkdownAssetPreview_REJECTED',

  DETACH_customProjectMarkdownAssetPreview = 'customProjectsSite_DETACH_customProjectMarkdownAssetPreview',
  DETACH_customProjectMarkdownAssetPreview_PENDING = 'customProjectsSite_DETACH_customProjectMarkdownAssetPreview_PENDING',
  DETACH_customProjectMarkdownAssetPreview_FULFILLED = 'customProjectsSite_DETACH_customProjectMarkdownAssetPreview_FULFILLED',
  DETACH_customProjectMarkdownAssetPreview_REJECTED = 'customProjectsSite_DETACH_customProjectMarkdownAssetPreview_REJECTED',

  //--- custom project test asset files

  SET_isAddCustomProjectCustomTestAssetFilesModalDisplayed = 'customProjectsSite_SET_isAddCustomProjectCustomTestAssetFilesModalDisplayed',
  SET_addCustomProjectCustomTestAssetFilesModalFilterText = 'customProjectsSite_SET_addCustomProjectCustomTestAssetFilesModalFilterText',
  SET_addCustomProjectCustomTestAssetFilesModalUploadPercentage = 'customProjectsSite_SET_addCustomProjectCustomTestAssetFilesModalUploadPercentage',

  ATTACH_customProjectCustomTestAssetPreview = 'customProjectsSite_ATTACH_customProjectCustomTestAssetPreview',
  ATTACH_customProjectCustomTestAssetPreview_PENDING = 'customProjectsSite_ATTACH_customProjectCustomTestAssetPreview_PENDING',
  ATTACH_customProjectCustomTestAssetPreview_FULFILLED = 'customProjectsSite_ATTACH_customProjectCustomTestAssetPreview_FULFILLED',
  ATTACH_customProjectCustomTestAssetPreview_REJECTED = 'customProjectsSite_ATTACH_customProjectCustomTestAssetPreview_REJECTED',

  DETACH_customProjectCustomTestAssetPreview = 'customProjectsSite_DETACH_customProjectCustomTestAssetPreview',
  DETACH_customProjectCustomTestAssetPreview_PENDING = 'customProjectsSite_DETACH_customProjectCustomTestAssetPreview_PENDING',
  DETACH_customProjectCustomTestAssetPreview_FULFILLED = 'customProjectsSite_DETACH_customProjectCustomTestAssetPreview_FULFILLED',
  DETACH_customProjectCustomTestAssetPreview_REJECTED = 'customProjectsSite_DETACH_customProjectCustomTestAssetPreview_REJECTED',

  //--- do editor

  SET_hasFileChangedMap = 'customProjectsSite_SET_hasFileChangedMap',
  SET_hasUnsavedChanges = 'customProjectsSite_SET_hasUnsavedChanges',
  SET_forceEditorUpdateSessionDummy = 'customProjectsSite_SET_forceEditorUpdateSessionDummy',

  SET_selectedTabIdCustomProjectSolutionEditor = 'customProjectsSite_SET_selectedTabIdCustomProjectSolutionEditor',
  SET_isFileExplorerDisplayedCustomProjectSolutionEditor = 'customProjectsSite_SET_isFileExplorerDisplayedCustomProjectSolutionEditor',
  SET_newFileNameCustomProjectSolutionEditor = 'customProjectsSite_SET_newFileNameCustomProjectSolutionEditor',
  SET_renamingFileIdCustomProjectSolutionEditor = 'customProjectsSite_SET_renamingFileIdCustomProjectSolutionEditor',
  SET_isRenamingFileCustomProjectSolutionEditor = 'customProjectsSite_SET_isRenamingFileCustomProjectSolutionEditor',
  SET_renamingFileNameCustomProjectSolutionEditor = 'customProjectsSite_SET_renamingFileNameCustomProjectSolutionEditor',
  SET_selectedPLangId = 'customProjectsSite_SET_selectedPLangId',


  SET_displayName = 'customProjectsSite_SET_displayName',
  SET_solution = 'customProjectsSite_SET_solution',
  SET_tests = 'customProjectsSite_SET_tests',

  SET_justRunProgramArgs = "customProjectsSite_SET_justRunProgramArgs",
  SET_isJustRunProgramArgsInputDisplayed = "customProjectsSite_SET_isJustRunProgramArgsInputDisplayed",


  SET_isChoosePLangDialogDisplayed = 'customProjectsSite_SET_isChoosePLangDialogDisplayed',

  RESET_TestResults = 'customProjectsSite_RESET_TestResults',

  RESET = 'editCustomProjectSiteReducer_RESET',
}
