/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../_notExhausiveHelper";
import {initial, State} from "./exerciseEditorSiteReducer";
import {
  GET_groupsForExercises_PENDINGAction,
  GET_groupsForExercises_FULFILLEDAction,
  GET_groupsForExercises_REJECTEDAction
} from "../manageGroupExercisesSite/getGroupsForExercisesCrudReducer";
import {ActionType} from "../manageGroupExercisesSite/groupExercisesSiteActionTypes";
import {FrontendSettingsManager} from '../../../helpers/frontendSettingsManager'


export type AllActions =
  GET_groupsForExercises_PENDINGAction
  | GET_groupsForExercises_FULFILLEDAction
  | GET_groupsForExercises_REJECTEDAction


export function reducer(state: State = initial(), action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_groupsForExercises_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_groupsForExercises_FULFILLED:

      // tslint:disable-next-line
      let lastNewExerciseGroupId = FrontendSettingsManager.getFrontendSettings().lastNewExerciseGroupId

      if (action.payload.length > 0) {

        if (action.payload.some(p => p.id === lastNewExerciseGroupId)) {
            //ok
        } else {
          lastNewExerciseGroupId = -1
        }
      }

      return {
        ...state,
        isLoading: false,
        groups: action.payload,
        editorExercise: {
          ...state.editorExercise,
          exerciseProperties: {
            ...state.editorExercise.exerciseProperties,
            userGroupId: lastNewExerciseGroupId //exercise must be loaded after this else we overwrite the real userGroupId in from the exercise!
          }
        }
      }
    case ActionType.GET_groupsForExercises_REJECTED:
      return {
        ...state,
        isLoading: false,
        groups: []
      }

    default:
      notExhaustive(action)
      return state
  }
}

