/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../_notExhausiveHelper";
import {
  GET_tags_FULFILLEDAction,
  GET_tags_PENDINGAction,
  GET_tags_REJECTEDAction
} from "../manageTagsSite/getTagsReducer";
import {initial, State} from "./exerciseEditorSiteReducer";
import {ActionType} from "../manageTagsSite/manageTagsSiteActionTypes";

//do nothing here but just reduce the actions so we get the data too

export type AllActions =
  GET_tags_PENDINGAction
  | GET_tags_FULFILLEDAction
  | GET_tags_REJECTEDAction


export function reducer(state: State = initial(), action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_tags_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_tags_FULFILLED:
      return {
        ...state,
        isLoading: false,
        tags: action.payload
      }
    case ActionType.GET_tags_REJECTED:
      return {
        ...state,
        isLoading: false,
        tags: []
      }

    default:
      notExhaustive(action)
      return state
  }
}

