/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../../_notExhausiveHelper";
import {EditorExerciseMetaDataFullBase} from "../../../../types/exerciseEditor";
import {ActionBase, ActionType} from "../editorExerciseSiteActionTypes";
import {getNextFrontendId} from "../../../../helpers/frontendIdHelper";

export type State = EditorExerciseMetaDataFullBase


export const initial: () => State = () => {
  return {
    id: getNextFrontendId(),
    tagIds: [],
  }
}

export interface SET_editorExerciseMetaDataIdAction extends ActionBase {
  readonly type: ActionType.SET_editorExerciseMetaDataId
  readonly id: number
}

export interface SET_tagIdsAction extends ActionBase {
  readonly type: ActionType.SET_tagIds
  readonly tagIds: ReadonlyArray<number>
}


export type AllActions =
  SET_editorExerciseMetaDataIdAction
  | SET_tagIdsAction


export function reducer(state: State = initial(), action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_editorExerciseMetaDataId:
      return {
        ...state,
        id: action.id

      }
    case ActionType.SET_tagIds:
      return {
        ...state,
        tagIds: action.tagIds
      }


    default:
      notExhaustive(action)
      return state
  }
}

