/**
 * Created by janis dähne.
 */

import {combineReducers} from 'redux'
import {reducer as loginReducer, State as LoginState} from './loginReducer'
import {reducer as userDataSettingsReducer, State as UserDataSettingsState} from './settingsSite/settingsSiteReducers'
import {reducer as systemRolesReducer, State as SystemRolesState} from './systemRolesSite/systemRolesSiteReducer'

import {
  reducer as activatedUsersReducer, State as ActivatedUsersState
} from './manageActivatedUsersSite/manageActivatedUsersSiteReducer'
import {reducer as newUsersReducer, State as NewUsersState} from './manageNewUsersSite/manageNewUsersSiteReducer'

import {reducer as groupRolesReducer, State as GroupRolesState} from './groupRolesSite/groupRolesSiteReducer'
import {reducer as groupsReducer, State as GroupsState} from './groupsSite/groupsSiteReducer'
import {reducer as singleGroupReducer, State as SingleGroupState} from './singleGroupSite/singleGroupSiteReducer'
import {
  reducer as OwnExercisesReducer, State as OwnExercisesState
} from './manageOwnExercisesSite/ownExercisesSiteReducer'
import {
  reducer as groupExercisesReducer, State as GroupExercisesState
} from './manageGroupExercisesSite/groupExercisesSiteReducer'
import {reducer as siteHeadBarReducer, State as SiteHeadBarState} from './siteHeaderBarReducer'
import {reducer as loggerPanelReducer, State as LoggerPanelState} from './loggerPanelReducer'
import {reducer as manageTagsReducer, State as ManageTagsState} from './manageTagsSite/manageTagsSiteReducer'
import {reducer as browserHistoryReducer, State as BrowserHistoryState} from './browserHistoryReducer'
import {
  reducer as releaseSiteReducer, State as ReleaseSiteState
} from './ownOrGroupExerciseReducers/exerciseReleasesSite/releaseSiteReducer'
import {
  reducer as submissionsSiteReducer, State as SubmissionsSiteState
} from './ownOrGroupExerciseReducers/submissionsSite/submissionsSiteReducer'
import {
  reducer as systemRolesChangeDialogReducer, State as SystemRolesChangeDialogState
} from './systemRolesSite/dialog/changeSystemRolesDialogReducer'

import {
  reducer as groupRolesChangeDialogReducer, State as GroupRolesChangeDialogState
} from './groupRolesSite/groupRoleReducer/changeGroupRolesDialogReducer'

import {
  reducer as changeTagDialogReducer, State as ChangeTagDialogState
} from './manageTagsSite/dialog/changeTagDialogReducer'
import {
  reducer as changeActivatedUserDataDialogReducer, State as ChangeActivatedUserDataDialogReducerState
} from './manageActivatedUsersSite/dialog/changeActivatedUserDataDialogReducer'


import {
  reducer as openExercisesReducer, State as OpenExercisesState
} from './allAccessibleExercises/openExercisesSite/openExercisesSiteReducer'
import {
  reducer as closedExercisesReducer, State as ClosedExercisesState
} from './allAccessibleExercises/closedExercisesSite/closedExercisesSiteReducer'

import {
  reducer as enterReleaseCodeDialogReducer, State as EnterReleaseCodeDialogState
} from './allAccessibleExercises/openExercisesSite/enterReleaseCodeDialog/enterReleaseCodeDialogReducer'


import {reducer as changeGroupReducer, State as ChangeGroupState} from './groupsSite/dialog/changeGroupReducer'
import {
  reducer as addUserDialogReducer, State as AddUserDialogState
} from './singleGroupSite/dialogs/addUsers/addUsersDialogReducer'
import {
  reducer as zoomedExerciseReleaseReducer, State as ZoomedExerciseReleaseState
} from './ownOrGroupExerciseReducers/exerciseReleasesSite/dialogs/zoomedRelease/zoomedReleaseDialogReducer'
import {
  reducer as changeExerciseReleaseDialogReducer, State as ChangeExerciseReleaseDialogState
} from './ownOrGroupExerciseReducers/exerciseReleasesSite/dialogs/changeExerciseReleaseDialog/changeExerciseReleaseDialogReducer'

import {
  reducer as pLangsReducer, State as PLangsState
} from './plangSettingsView/pLangsReducer'
import {reducer as langsReducer, State as LangsState} from './langsView/langsViewReducer'

import {
  reducer as exerciseEditorSiteReducer, State as ExerciseEditorState
} from './exerciseEditorSite/exerciseEditorSiteReducer'

import {
  reducer as testTypesReducer, State as TestTypesState
} from './testTypesReducer'

import {
  reducer as changeTestDialogReducer, State as ChangeTestDialogState
} from './exerciseEditorSite/dialogs/changeTestDialog/changeTestDialogReducer'

import {
  reducer as changeSelectedTagsDialogReducer, State as ChangeSelectedTagsDialogState
} from './exerciseEditorSite/dialogs/changeSelectedTagsDialog/changeSelectedTagsDialogReducer'

import {
  reducer as changeCodeTemplateDialogReducer, State as ChangeCodeTemplateDialogState
} from './exerciseEditorSite/dialogs/changeCodeTemplateDialog/changeCodeTemplateDialogReducer'
import {
  reducer as editorSettingsDialogReducer, State as EditorSettingsDialogState
} from './editorSettingsDialog/editorSettingsDialogReducer'

import {reducer as doExerciseSiteReducer, State as DoExerciseSiteState} from './doExerciseSite/doExerciseSiteReducer'


import {
  reducer as globalSystemSettingsReducer,
  State as GlobalSystemSettingsState
} from './globalSystemSettings/globalSystemSettingsReducer'

import {
  reducer as systemSettingsSiteReducer,
  State as SystemSettingsSiteState
} from './systemSettingsSite/systemSettingsSiteReducer'

import {
  reducer as changeCustomTestDialogReducer, State as ChangeCustomTestDialogState
} from './doExerciseSite/dialogs/changeCustomTestDialog/changeCustomTestDialogReducer'


import {
  reducer as viewTestDialogReducer, State as ViewTestDialogState
} from './doExerciseSite/dialogs/viewTestDialog/viewTestDialogReducer'

import {reducer as tutorViewSiteReducer, State as TutorViewSiteState} from './tutorViewSite/tutorViewSiteReducer'


import {
  reducer as assessmentStatisticsSiteReducer, State as AssessmentStatisticsSiteState
} from './assessmentStatisticsSite/assessmentStatisticsSiteReducer'


import {reducer as tagsFilterReducer, State as TagsFilterState} from './tagsFilterReducer'

import {
  reducer as groupStorageReducer, State as GroupStorageState
} from './groupStorage/groupStorageReducer'


import {
  reducer as manageCustomProjectsSiteReducer, State as ManageCustomProjectsSiteState
} from './manageCustomProjectsSite/manageCustomProjectsSiteReducer'

import {
  reducer as editCustomProjectSiteReducer, State as EditCustomProjectSiteState
} from './editCustomProjectSite/editCustomProjectSiteReducer'

import {
  reducer as changeCustomProjectTestDialogReducer, State as ChangeCustomProjectTestDialogState
} from './editCustomProjectSite/dialogs/changeCustomProjectTestDialog/changeCustomProjectTestDialogReducer'


import {reducer as dashboardSiteReducer, State as DashboardSiteState} from './dashboardSite/dashboardSiteReducer'
import {reducer as i18nReducer, State as I18nState} from './i18nReducer'

import {reducer as globalUiReducer, State as GlobalUiState} from './globalUiReducer'
import {
  reducer as exportCsvDialogReducer,
  State as SubmissionExportCsvDialogState
} from './ownOrGroupExerciseReducers/submissionsSite/exportCsvDialog/exportCsvDialogReducer'

export interface RootState {

  readonly dashboardSiteState: DashboardSiteState

  readonly changeCustomProjectTestDialogState: ChangeCustomProjectTestDialogState

  readonly editCustomProjectSiteState: EditCustomProjectSiteState

  readonly manageCustomProjectsSiteState: ManageCustomProjectsSiteState

  readonly groupStorageState: GroupStorageState


  readonly tagsFilterState: TagsFilterState

  readonly tutorViewSiteState: TutorViewSiteState

  readonly assessmentStatisticsSiteState: AssessmentStatisticsSiteState

  readonly doExerciseSiteState: DoExerciseSiteState
  readonly changeCustomTestDialogState: ChangeCustomTestDialogState
  readonly viewTestDialogState: ViewTestDialogState

  readonly exerciseEditorState: ExerciseEditorState

  readonly changeTestDialogState: ChangeTestDialogState
  readonly changeSelectedTagsDialogState: ChangeSelectedTagsDialogState
  readonly changeCodeTemplateDialogState: ChangeCodeTemplateDialogState
  readonly editorSettingsDialogState: EditorSettingsDialogState

  readonly testTypesState: TestTypesState

  readonly loginDataState: LoginState;
  readonly userDataSettingsSate: UserDataSettingsState;

  readonly openExercisesState: OpenExercisesState
  readonly enterReleaseCodeDialogState: EnterReleaseCodeDialogState
  readonly closedExercisesState: ClosedExercisesState

  readonly systemRolesState: SystemRolesState
  readonly systemRolesChangeDialogState: SystemRolesChangeDialogState

  readonly manageActivatedUsersState: ActivatedUsersState
  readonly changeActivatedUsersDataDialogState: ChangeActivatedUserDataDialogReducerState

  readonly manageNewUsersState: NewUsersState

  readonly groupRolesState: GroupRolesState
  readonly groupRolesChangeDialogState: GroupRolesChangeDialogState


  readonly groupsState: GroupsState
  readonly changeGroupDialogState: ChangeGroupState


  readonly singleGroupState: SingleGroupState
  readonly addUsersDialogState: AddUserDialogState


  readonly manageOwnExercisesState: OwnExercisesState
  readonly manageGroupExercisesState: GroupExercisesState
  readonly releaseSiteState: ReleaseSiteState
  readonly zoomedExerciseReleaseState: ZoomedExerciseReleaseState
  readonly changeExerciseReleaseDialogState: ChangeExerciseReleaseDialogState

  readonly submissionsSiteState: SubmissionsSiteState
  readonly submissionExportCsvDialogState: SubmissionExportCsvDialogState


  readonly pLangsState: PLangsState
  readonly langsState: LangsState


  readonly siteHeaderBarState: SiteHeadBarState
  readonly loggerPanelState: LoggerPanelState

  readonly manageTagsState: ManageTagsState
  readonly changeTagDialogState: ChangeTagDialogState


  readonly globalSystemSettingsState: GlobalSystemSettingsState

  readonly systemSettingsSiteState: SystemSettingsSiteState

  readonly browserHistoryState: BrowserHistoryState

  readonly i18nState: I18nState

  readonly globalUiState: GlobalUiState

}

//what reducer for what state?
export default combineReducers<RootState>({

                                            dashboardSiteState: dashboardSiteReducer,

                                            changeCustomProjectTestDialogState: changeCustomProjectTestDialogReducer,

                                            editCustomProjectSiteState: editCustomProjectSiteReducer,

                                            manageCustomProjectsSiteState: manageCustomProjectsSiteReducer,

                                            groupStorageState: groupStorageReducer,

                                            tagsFilterState: tagsFilterReducer,

                                            tutorViewSiteState: tutorViewSiteReducer,

                                            assessmentStatisticsSiteState: assessmentStatisticsSiteReducer,

                                            doExerciseSiteState: doExerciseSiteReducer,
                                            changeCustomTestDialogState: changeCustomTestDialogReducer,
                                            viewTestDialogState: viewTestDialogReducer,

                                            exerciseEditorState: exerciseEditorSiteReducer,

                                            changeTestDialogState: changeTestDialogReducer,
                                            changeSelectedTagsDialogState: changeSelectedTagsDialogReducer,
                                            changeCodeTemplateDialogState: changeCodeTemplateDialogReducer,
                                            editorSettingsDialogState: editorSettingsDialogReducer,

                                            testTypesState: testTypesReducer,

                                            loginDataState: loginReducer,
                                            userDataSettingsSate: userDataSettingsReducer,

                                            openExercisesState: openExercisesReducer,
                                            enterReleaseCodeDialogState: enterReleaseCodeDialogReducer,
                                            closedExercisesState: closedExercisesReducer,

                                            systemRolesState: systemRolesReducer,
                                            systemRolesChangeDialogState: systemRolesChangeDialogReducer,

                                            manageActivatedUsersState: activatedUsersReducer,
                                            changeActivatedUsersDataDialogState: changeActivatedUserDataDialogReducer,

                                            manageNewUsersState: newUsersReducer,
                                            groupRolesState: groupRolesReducer,
                                            groupRolesChangeDialogState: groupRolesChangeDialogReducer,

                                            groupsState: groupsReducer,
                                            changeGroupDialogState: changeGroupReducer,

                                            singleGroupState: singleGroupReducer,
                                            addUsersDialogState: addUserDialogReducer,


                                            manageOwnExercisesState: OwnExercisesReducer,
                                            manageGroupExercisesState: groupExercisesReducer,
                                            releaseSiteState: releaseSiteReducer,
                                            zoomedExerciseReleaseState: zoomedExerciseReleaseReducer,
                                            changeExerciseReleaseDialogState: changeExerciseReleaseDialogReducer,

                                            submissionsSiteState: submissionsSiteReducer,

                                            submissionExportCsvDialogState: exportCsvDialogReducer,

                                            pLangsState: pLangsReducer,
                                            langsState: langsReducer,

                                            siteHeaderBarState: siteHeadBarReducer,
                                            loggerPanelState: loggerPanelReducer,

                                            manageTagsState: manageTagsReducer,
                                            changeTagDialogState: changeTagDialogReducer,

                                            globalSystemSettingsState: globalSystemSettingsReducer,

                                            systemSettingsSiteState: systemSettingsSiteReducer,

                                            browserHistoryState: browserHistoryReducer,

                                            i18nState: i18nReducer,

                                            globalUiState: globalUiReducer

                                          })

/**
 * used for everything else in CRUD than reading (reading is ReduxPromiseAction)
 */
export interface ReduxPromiseBaseAction<T, TMeta> {
  readonly payload: Promise<T>
  readonly meta?: TMeta //this is not really well documented ... see http://redux.js.org/docs/advanced/Middleware.html
}

/**
 * use this for the fetch actions (server communication)
 * this action is not in the reducer case because this doesn't get triggered
 * instead the redux promise middleware dispatch the [originalDispatchedName]_PENDING action
 *
 * so the types to use in the switch case in the reducer are:
 *
 * TPending: the pending type (just to ensure we not missed to implement this)
 * TFulfilled: the fulfilled type (just to ensure we not missed to implement this)
 * TRejected: the fulfilled type (just to ensure we not missed to implement this)
 *
 * however the actions (that are called in the components) only implement an action for [originalDispatchedName]
 * because the TPending, TFulfilled and TRejected are dispatched automatically
 *
 * usage:
 *
 * export interface GET_systemRolesAction
 *  extends ActionBase, ReduxPromiseAction<ReadonlyArray<SystemRoleFullBase>, GET_systemRoles_FULFILLEDAction, GET_systemRoles_REJECTEDAction> {
 *   readonly type: ActionType.GET_systemRoles
 *   readonly payload: Promise<ReadonlyArray<SystemRoleFullBase>>
 * }
 *
 * OR
 *
 * export interface Meta {...}
 *
 * export interface GET_systemRolesAction
 *  extends ActionBase, ReduxPromiseAction<ReadonlyArray<SystemRoleFullBase>, GET_systemRoles_FULFILLEDAction, GET_systemRoles_REJECTEDAction> {
 *   readonly type: ActionType.GET_systemRoles
 *   readonly payload: Promise<ReadonlyArray<SystemRoleFullBase>>
 *   readonly meta? TMeta
 * }
 *
 * export interface GET_systemRoles_FULFILLEDAction<SystemRoleFullBase, TMeta> {...}
 *
 *
 * for GET_systemRoles_FULFILLEDAction and GET_systemRoles_REJECTEDAction see below
 */
export interface ReduxPromiseAction<T, TPending extends ReduxPromisePendingAction<TMeta>, TFulfilled extends ReduxPromiseFulfilledAction<T, TMeta>, TRejected extends ReduxPromiseRejectedAction<T, TMeta>, TMeta = void>
  extends ReduxPromiseBaseAction<T, TMeta> {
  readonly meta?: TMeta
}

export interface ReduxPromisePendingAction<U> {
  readonly type: string //this is only used that typescript error goes away...
  readonly meta?: U
}

/**
 * use this for the fulfilled part of ReduxPromiseAction<T>
 * this is automatically dispatched by redux promise middleware
 *
 * usage:
 *
 * export interface GET_systemRoles_FULFILLEDAction
 *   extends ActionBase, ReduxPromiseFulfilledAction<ReadonlyArray<SystemRoleFullBase>> {
 * readonly type: ActionType.GET_systemRoles_FULFILLED
 * readonly payload: ReadonlyArray<SystemRoleFullBase>
 * }
 *
 */
export interface ReduxPromiseFulfilledAction<T, TMeta = void> {
  readonly payload: T
  readonly meta?: TMeta
}

/**
 *
 * use this for the rejected part of ReduxPromiseAction<T>
 * this is automatically dispatched by redux promise middleware
 * TODO remove T here?
 *
 * usage:
 *
 * export interface GET_systemRoles_REJECTEDAction
 *   extends ActionBase, ReduxPromiseRejectedAction<ReadonlyArray<SystemRoleFullBase>> {
 *  readonly type: ActionType.GET_systemRoles_REJECTED
 *  readonly payload: any
 * }
 */
export interface ReduxPromiseRejectedAction<T, TMeta = void> {
  readonly error: true
  readonly payload: any
  readonly meta?: TMeta
}

