/**
 * Created by janis dähne.
 */
import {Action} from "redux";
import {notExhaustive} from "../../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {ActionBase, ActionType} from "./changeActivatedUserDataDialogActionTypes";
import {State, initial} from "./changeActivatedUserDataDialogReducer";
import Logger from "../../../../helpers/logger";


export interface UPDATE_activatedUserSystemRoleDataAction
  extends ActionBase, ReduxPromiseAction<void, UPDATE_activatedUserSystemRoleData_PENDINGAction, UPDATE_activatedUserSystemRoleData_FULFILLEDAction, UPDATE_activatedUserSystemRoleData_REJECTEDAction> {
  readonly type: ActionType.UPDATE_activatedUserSystemRoleData
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface UPDATE_activatedUserSystemRoleData_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.UPDATE_activatedUserSystemRoleData_PENDING
}

//automatically dispatched by redux promise middleware
export interface UPDATE_activatedUserSystemRoleData_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.UPDATE_activatedUserSystemRoleData_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface UPDATE_activatedUserSystemRoleData_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.UPDATE_activatedUserSystemRoleData_REJECTED
  readonly payload: any
}


export type AllActions =
  UPDATE_activatedUserSystemRoleData_PENDINGAction
  | UPDATE_activatedUserSystemRoleData_FULFILLEDAction
  | UPDATE_activatedUserSystemRoleData_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.UPDATE_activatedUserSystemRoleData_PENDING:
      return {
        ...state,
        isBusy: true
      }
    case ActionType.UPDATE_activatedUserSystemRoleData_FULFILLED:
      return {
        ...state,
        isBusy: false
      }
    case ActionType.UPDATE_activatedUserSystemRoleData_REJECTED:
      return {
        ...state,
        isBusy: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

