/**
 * Created by janis dähne.
 */

import {ActionBase, ActionType} from "./releasesSiteActionTypes";
import {initial, State} from "./releaseSiteReducer";
import Logger from "../../../../helpers/logger";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {notExhaustive} from "../../_notExhausiveHelper";


export interface DELETE_exerciseReleaseAction
  extends ActionBase, ReduxPromiseAction<void, DELETE_exerciseRelease_PENDINGAction, DELETE_exerciseRelease_FULFILLEDAction, DELETE_exerciseRelease_REJECTEDAction> {
  readonly type: ActionType.DELETE_exerciseRelease
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface DELETE_exerciseRelease_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.DELETE_exerciseRelease_PENDING
}

//automatically dispatched by redux promise middleware
export interface DELETE_exerciseRelease_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.DELETE_exerciseRelease_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface DELETE_exerciseRelease_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.DELETE_exerciseRelease_REJECTED
  readonly payload: any
}


export type AllActions =
  DELETE_exerciseRelease_PENDINGAction
  | DELETE_exerciseRelease_FULFILLEDAction
  | DELETE_exerciseRelease_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.DELETE_exerciseRelease_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.DELETE_exerciseRelease_FULFILLED:
      return {
        ...state,
        isLoading: false
      }
    case ActionType.DELETE_exerciseRelease_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

