import {getValidationMessagesCollection} from "../../../../../../validation/validations";
import {ExerciseReleaseForBackend} from "../../../../../../types/exerciseRelease";
import {getI18n} from "../../../../../../../i18n/i18nRoot";
import globalState from "../../../../../state";

export const validationMessageKeys = getValidationMessagesCollection<ExerciseReleaseForBackend>({
  id: '',
  isReleased: '',
  releasedAt: '',
  generatedCode: '',
  pLangId: getI18n(globalState.getState().i18nState.langId,'Invalid option, take other'),
  automaticEndAt: '',
  automaticStartAt: '',
  availableWorkingTimeInMinutes: getI18n(globalState.getState().i18nState.langId,'Available working time must be set and >= 1'),
  note: '',
  hasLimitedWorkingTime: '',
  isVisibleToAllAfterRelease: '',
  shouldAutomaticAssessSubmissions: '',
  runAlsoNormalTests: '',
  releaseDurationType: '',
  releaseStartType: '',
  hasAutomaticAssessmentStarted: '',
  hasAutomaticAssessmentFinished: '',
  hadAutomaticAssessmentErrors: '',
  hideInOverviews: '',
  shouldClearClipboard: '',
  hideSiteHeaderBar: '',
  showAdditionalLogButton: '',
  hidePrintOptions: '',
  hideExerciseLeaveActions: '',
  maxManualPoints: '',
})
