import {ActionBase, ActionType} from './submissionsSiteActionTypes'
import {initial, State} from './submissionsSiteReducer'
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from '../../index'
import {notExhaustive} from '../../_notExhausiveHelper'



export interface UPLOAD_csvAssessmentFileAction
  extends ActionBase, ReduxPromiseAction<void, UPLOAD_csvAssessmentFile_PENDINGAction, UPLOAD_csvAsssessmentFile_FULFILLEDAction, UPLOAD_csvAssessmentFile_REJECTEDAction> {
  readonly type: ActionType.UPLOAD_csvAssessmentFile
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface UPLOAD_csvAssessmentFile_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.UPLOAD_csvAssessmentFile_PENDING
}

//automatically dispatched by redux promise middleware
export interface UPLOAD_csvAsssessmentFile_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.UPLOAD_csvAssessmentFile_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface UPLOAD_csvAssessmentFile_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.UPLOAD_csvAssessmentFile_REJECTED
  readonly payload: any
}


export type AllActions =
  UPLOAD_csvAssessmentFile_PENDINGAction
  | UPLOAD_csvAsssessmentFile_FULFILLEDAction
  | UPLOAD_csvAssessmentFile_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.UPLOAD_csvAssessmentFile_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.UPLOAD_csvAssessmentFile_FULFILLED:
      return {
        ...state,
        isLoading: false
      }
    case ActionType.UPLOAD_csvAssessmentFile_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

