import {PLangFullBase} from '../../../../types/pLangs'
import {ActionBase, ActionType} from '../pLangsSettingsViewActionTypes'
import {initial, State} from '../pLangsReducer'
import {notExhaustive} from '../../_notExhausiveHelper'
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from '../../index'



export interface GET_pLangsAction
  extends ActionBase, ReduxPromiseAction<ReadonlyArray<PLangFullBase>, GET_pLangs_PENDINGAction, GET_pLangs_FULFILLEDAction, GET_pLangs_REJECTEDAction> {
  readonly type: ActionType.GET_pLangs
  readonly payload: Promise<ReadonlyArray<PLangFullBase>>
}

//automatically dispatched by redux promise middleware
export interface GET_pLangs_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_pLangs_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_pLangs_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<ReadonlyArray<PLangFullBase>> {
  readonly type: ActionType.GET_pLangs_FULFILLED
  readonly payload: ReadonlyArray<PLangFullBase>
}

//automatically dispatched by redux promise middleware
export interface GET_pLangs_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_pLangs_REJECTED
  readonly payload: any
}



export type AllActions =
  GET_pLangs_PENDINGAction
  | GET_pLangs_FULFILLEDAction
  | GET_pLangs_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_pLangs_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_pLangs_FULFILLED:
      return {
        ...state,
        isLoading: false,
        pLangs: action.payload,
      }
    case ActionType.GET_pLangs_REJECTED:
      return {
        ...state,
        isLoading: false,
        pLangs: [],
      }

    default:
      notExhaustive(action)
      return state
  }
}

