/**
 * Created by janis dähne.
 */

import {Action} from "redux";
import {notExhaustive} from "../../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {initial, State} from "./changeSystemRolesDialogReducer";
import {SystemRoleFullBase} from "../../../../types/userData";
import {ActionType, ActionBase} from "./changeSystemRoleDIalogActionTypes";



export interface CREATE_systemRoleAction
  extends ActionBase, ReduxPromiseAction<SystemRoleFullBase, CREATE_systemRole_PENDINGAction, CREATE_systemRole_FULFILLEDAction, CREATE_systemRole_REJECTEDAction> {
  readonly type: ActionType.CREATE_systemRole
  readonly payload: Promise<SystemRoleFullBase>
}

//automatically dispatched by redux promise middleware
export interface CREATE_systemRole_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.CREATE_systemRole_PENDING
}

//automatically dispatched by redux promise middleware
export interface CREATE_systemRole_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<SystemRoleFullBase> {
  readonly type: ActionType.CREATE_systemRole_FULFILLED
  readonly payload: SystemRoleFullBase
}

//automatically dispatched by redux promise middleware
export interface CREATE_systemRole_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<SystemRoleFullBase> {
  readonly type: ActionType.CREATE_systemRole_REJECTED
  readonly payload: any
}


export type AllActions =
  CREATE_systemRole_PENDINGAction
  | CREATE_systemRole_FULFILLEDAction
  | CREATE_systemRole_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.CREATE_systemRole_PENDING:
      return {
        ...state,
        isBusy: true
      }
    case ActionType.CREATE_systemRole_FULFILLED:
      return {
        ...state,
        isBusy: false,
      }
    case ActionType.CREATE_systemRole_REJECTED:
      return {
        ...state,
        isBusy: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

