import {ActionBase, ActionType} from '../systemSettingsSiteActionTypes'
import {State, initial} from '../systemSettingsSiteReducer'
import {ReduxPromiseAction, ReduxPromiseFulfilledAction,ReduxPromiseRejectedAction} from '../../index'
import {notExhaustive} from '../../_notExhausiveHelper'
import {SystemSettingsFromBackend} from '../../../../types/systemSettings'


export interface GET_initialSystemSettingsAction
  extends ActionBase, ReduxPromiseAction<SystemSettingsFromBackend, GET_initialSystemSettings_PENDINGAction, GET_initialSystemSettings_FULFILLEDAction, GET_initialSystemSettings_REJECTEDAction> {
  readonly type: ActionType.GET_initialSystemSettings
  readonly payload: Promise<SystemSettingsFromBackend>
}

//automatically dispatched by redux promise middleware
export interface GET_initialSystemSettings_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_initialSystemSettings_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_initialSystemSettings_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<SystemSettingsFromBackend> {
  readonly type: ActionType.GET_initialSystemSettings_FULFILLED
  readonly payload: SystemSettingsFromBackend
}

//automatically dispatched by redux promise middleware
export interface GET_initialSystemSettings_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_initialSystemSettings_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_initialSystemSettings_PENDINGAction
  | GET_initialSystemSettings_FULFILLEDAction
  | GET_initialSystemSettings_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_initialSystemSettings_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_initialSystemSettings_FULFILLED:
      return {
        ...state,
        isLoading: false,
        initialSystemSettings: action.payload
      }
    case ActionType.GET_initialSystemSettings_REJECTED:
      return {
        ...state,
        isLoading: false,
        initialSystemSettings: null
      }

    default:
      notExhaustive(action)
      return state
  }
}

