/**
 * Created by janis dähne.
 */

import {ActionBase, ActionType} from "../tutorViewSiteActionTypes";
import {notExhaustive} from "../../_notExhausiveHelper";
import {HasFileChangedMap} from "../../../../helpers/editorHelper";
import {DoEditorState, initial as initialEditorState} from "../../doExerciseSite/editorReducers/doEditorReducer";


export const initial: DoEditorState = {
  ...initialEditorState
}


//--- do editor

export interface SET_tutorEditor_hasFileChangedMapAction extends ActionBase {
  readonly type: ActionType.SET_tutorEditor_hasFileChangedMap
  readonly hasFileChangedMap: HasFileChangedMap
}

export interface SET_tutorEditor_hasUnsavedChangesAction extends ActionBase {
  readonly type: ActionType.SET_tutorEditor_hasUnsavedChanges
  readonly hasUnsavedChanges: boolean
}

export interface SET_tutorEditor_selectedTabIdDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_tutorEditor_selectedTabIdDoEditor
  readonly selectedTabIdDoEditor: number
}

export interface SET_tutorEditor_isFileExplorerDisplayedDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_tutorEditor_isFileExplorerDisplayedDoEditor
  readonly isFileExplorerDisplayedDoEditor: boolean
}

export interface SET_tutorEditor_newFileNameDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_tutorEditor_newFileNameDoEditor
  readonly newFileNameDoEditor: string
}

export interface SET_tutorEditor_renamingFileIdDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_tutorEditor_renamingFileIdDoEditor
  readonly renamingFileIdDoEditor: number
}

export interface SET_tutorEditor_isRenamingFileDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_tutorEditor_isRenamingFileDoEditor
  readonly isRenamingFileDoEditor: boolean
}

export interface SET_tutorEditor_renamingFileNameDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_tutorEditor_renamingFileNameDoEditor
  readonly renamingFileNameDoEditor: string
}


export type AllActions =
  SET_tutorEditor_selectedTabIdDoEditorAction
  | SET_tutorEditor_isFileExplorerDisplayedDoEditorAction
  | SET_tutorEditor_newFileNameDoEditorAction
  | SET_tutorEditor_renamingFileIdDoEditorAction
  | SET_tutorEditor_isRenamingFileDoEditorAction
  | SET_tutorEditor_renamingFileNameDoEditorAction
  | SET_tutorEditor_hasUnsavedChangesAction
  | SET_tutorEditor_hasFileChangedMapAction


export function reducer(state: DoEditorState = initial, action: AllActions): DoEditorState {

  switch (action.type) {

    case ActionType.SET_tutorEditor_hasFileChangedMap:
      return {
        ...state,
        hasFileChangedMap: action.hasFileChangedMap
      }

    case ActionType.SET_tutorEditor_hasUnsavedChanges:
      return {
        ...state,
        hasUnsavedChanges: action.hasUnsavedChanges
      }

    case ActionType.SET_tutorEditor_selectedTabIdDoEditor:
      return {
        ...state,
        selectedTabIdDoEditor: action.selectedTabIdDoEditor
      }
    case ActionType.SET_tutorEditor_isFileExplorerDisplayedDoEditor:
      return {
        ...state,
        isFileExplorerDisplayedDoEditor: action.isFileExplorerDisplayedDoEditor
      }
    case ActionType.SET_tutorEditor_newFileNameDoEditor:
      return {
        ...state,
        newFileNameDoEditor: action.newFileNameDoEditor
      }
    case ActionType.SET_tutorEditor_renamingFileIdDoEditor:
      return {
        ...state,
        renamingFileIdDoEditor: action.renamingFileIdDoEditor
      }
    case ActionType.SET_tutorEditor_isRenamingFileDoEditor:
      return {
        ...state,
        isRenamingFileDoEditor: action.isRenamingFileDoEditor
      }
    case ActionType.SET_tutorEditor_renamingFileNameDoEditor:
      return {
        ...state,
        renamingFileNameDoEditor: action.renamingFileNameDoEditor
      }

    default:
      notExhaustive(action)
      return state
  }
}

