import {FileIdAssociation, SolutionFileDoExerciseFullBase} from './exerciseSolution'
import {Moment} from 'moment'


export interface AfterSolutionTupleFromBackend {
  /**
   * the solution for the frontend
   */
  readonly solution: AfterSolutionDoExerciseFullBase

  /**
   * if we change/create a new file in the frontend then we send back the saved version (backend version) to the frontend
   * because the frontend can replace the file (else the undo history would be lost/corrupted) it needs to set the
   * file content directly. for this we need to know which old/frontend file had which content
   */
  readonly fileIdAssociationMap: ReadonlyArray<FileIdAssociation>
}

export interface AfterSolutionDoExerciseFullBase {
  readonly id: number

  readonly userId: number
  readonly releaseId: number
  readonly pLangId: number

  /**
   * the main file id (where the entry point is declared, e.g. public static void main...)
   */
  readonly mainFileId: number

  /**
   * the datetime when the version was ?
   */
  readonly lastUpdatedAt: Moment
  /**
   * the files for this solution
   */
  readonly solutionFiles: ReadonlyArray<SolutionFileDoExerciseFullBase>
}