/**
 * Created by janis dähne.
 */

export interface GroupRoleFullBase {

  readonly id: number
  /**
   * the display name
   */
  readonly displayName: string
}

/**
 * the system role for an user (member)
 * see backend type GroupRolePermission for permission description
 */
export interface GroupRoleWithPermissionFullBase extends GroupRoleFullBase {

  //permissions
  readonly canCreateExercises: boolean
  readonly canChangeExercises: boolean
  readonly canDeleteExercises: boolean
  readonly canLockExercisesPermanently: boolean

  readonly canManageExerciseReleases: boolean
  readonly canAssessExercises: boolean

  readonly canSeeExercisesFromOthersInGroup: boolean

  readonly canAddUserToGroup: boolean
  readonly canRemoveMemberFromGroup: boolean
  readonly canChangeOtherMembersRole: boolean

  readonly canSeeOtherMembers: boolean

  readonly canChangeGroupData: boolean

}


